
/*  A Bison parser, made from pic.y  */

#define	LABEL	258
#define	VARIABLE	259
#define	NUMBER	260
#define	TEXT	261
#define	COMMAND_LINE	262
#define	DELIMITED	263
#define	ORDINAL	264
#define	LEFT_ARROW_HEAD	265
#define	RIGHT_ARROW_HEAD	266
#define	DOUBLE_ARROW_HEAD	267
#define	LAST	268
#define	UP	269
#define	DOWN	270
#define	LEFT	271
#define	RIGHT	272
#define	BOX	273
#define	CIRCLE	274
#define	ELLIPSE	275
#define	ARC	276
#define	LINE	277
#define	ARROW	278
#define	MOVE	279
#define	SPLINE	280
#define	HEIGHT	281
#define	RADIUS	282
#define	WIDTH	283
#define	DIAMETER	284
#define	FROM	285
#define	TO	286
#define	AT	287
#define	WITH	288
#define	BY	289
#define	THEN	290
#define	DOTTED	291
#define	DASHED	292
#define	CHOP	293
#define	SAME	294
#define	INVISIBLE	295
#define	LJUST	296
#define	RJUST	297
#define	ABOVE	298
#define	BELOW	299
#define	OF	300
#define	THE	301
#define	WAY	302
#define	BETWEEN	303
#define	AND	304
#define	HERE	305
#define	DOT_N	306
#define	DOT_E	307
#define	DOT_W	308
#define	DOT_S	309
#define	DOT_NE	310
#define	DOT_SE	311
#define	DOT_NW	312
#define	DOT_SW	313
#define	DOT_C	314
#define	DOT_START	315
#define	DOT_END	316
#define	DOT_X	317
#define	DOT_Y	318
#define	DOT_HT	319
#define	DOT_WID	320
#define	DOT_RAD	321
#define	SIN	322
#define	COS	323
#define	ATAN2	324
#define	LOG	325
#define	EXP	326
#define	SQRT	327
#define	MAX	328
#define	MIN	329
#define	INT	330
#define	RAND	331
#define	COPY	332
#define	THRU	333
#define	TOP	334
#define	BOTTOM	335
#define	UPPER	336
#define	LOWER	337
#define	SH	338
#define	PRINT	339
#define	CW	340
#define	CCW	341
#define	FOR	342
#define	DO	343
#define	IF	344
#define	ELSE	345
#define	ANDAND	346
#define	OROR	347
#define	NOTEQUAL	348
#define	EQUALEQUAL	349
#define	LESSEQUAL	350
#define	GREATEREQUAL	351
#define	LEFT_CORNER	352
#define	RIGHT_CORNER	353
#define	CENTER	354
#define	END	355
#define	START	356
#define	RESET	357
#define	UNTIL	358
#define	PLOT	359
#define	THICKNESS	360
#define	FILL	361
#define	ALIGNED	362
#define	SPRINTF	363
#define	COMMAND	364
#define	DEFINE	365
#define	UNDEF	366

#line 19 "pic.y"

#include "pic.h"
#include "ptable.h"
#include "object.h"

extern int delim_flag;
extern void do_copy(const char *);
extern void copy_rest_thru(const char *, const char *);
extern void copy_file_thru(const char *, const char *, const char *);
extern void push_body(const char *);
extern void do_for(char *var, double from, double to,
		   int by_is_multiplicative, double by, char *body);
extern void do_lookahead();

extern "C" {
  double fmod(double, double);
  int rand();
}

/* Maximum number of characters produced by printf("%g") */
#define GDIGITS 14

#ifndef __BORLANDC__
#define YYDEBUG 1
#endif /* __BORLANDC__ */

int yylex();
void yyerror(const char *);

void reset(const char *nm);
void reset_all();

place *lookup_label(const char *);
void define_label(const char *label, const place *pl);

direction current_direction;
position current_position;

implement_ptable(place)

PTABLE(place) top_table;

PTABLE(place) *current_table = &top_table;
saved_state *current_saved_state = 0;

object_list olist;

const char *ordinal_postfix(int n);
const char *object_type_name(object_type type);
char *format_number(const char *form, double n);
char *do_sprintf(const char *form, const double *v, int nv);


#line 74 "pic.y"
typedef union {
	char *str;
	int n;
	double x;
	struct { double x, y; } pair;
	struct { double x; char *body; } if_data;
	struct { char *str; const char *filename; int lineno; } lstr;
	struct { double *v; int nv; int maxv; } dv;
	struct { double val; int is_multiplicative; } by;
	place pl;
	object *obj;
	corner crn;
	path *pth;
	object_spec *spec;
	saved_state *pstate;
	graphics_state state;
	object_type obtype;
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __STDC__
#define const
#endif



#define	YYFINAL		400
#define	YYFLAG		-32768
#define	YYNTBASE	132

#define YYTRANSLATE(x) ((unsigned)(x) <= 366 ? yytranslate[x] : 176)

static const short yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,   121,     2,     2,     2,   120,     2,     2,   112,
   130,   118,   116,   113,   117,   131,   119,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,   125,   123,   114,
   124,   115,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
   128,     2,   129,   122,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,   126,     2,   127,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
    96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
   106,   107,   108,   109,   110,   111
};

static const short yyprhs[] = {     0,
     0,     2,     4,     8,    10,    14,    15,    17,    19,    22,
    26,    31,    33,    35,    37,    39,    41,    44,    47,    48,
    52,    55,    56,    57,    65,    66,    67,    74,    75,    86,
    88,    89,    94,    96,    98,   101,   104,   108,   110,   113,
   115,   117,   119,   120,   126,   127,   130,   132,   134,   138,
   142,   146,   150,   154,   158,   162,   166,   169,   170,   173,
   177,   179,   184,   189,   194,   195,   196,   203,   205,   206,
   208,   210,   212,   214,   216,   218,   220,   222,   224,   226,
   229,   233,   234,   239,   243,   247,   251,   255,   258,   261,
   265,   268,   272,   275,   279,   282,   286,   290,   294,   298,
   302,   306,   309,   312,   316,   319,   323,   326,   330,   333,
   337,   340,   343,   346,   349,   352,   355,   358,   361,   364,
   367,   370,   373,   377,   380,   382,   388,   389,   393,   395,
   397,   399,   403,   407,   413,   419,   426,   428,   433,   437,
   441,   443,   446,   449,   453,   455,   457,   459,   463,   465,
   468,   471,   474,   476,   478,   480,   482,   484,   486,   488,
   491,   493,   496,   500,   502,   504,   507,   509,   514,   518,
   522,   525,   527,   529,   531,   533,   535,   537,   539,   541,
   543,   545,   547,   549,   551,   553,   555,   558,   561,   564,
   567,   569,   571,   574,   577,   580,   583,   585,   587,   589,
   591,   593,   596,   599,   602,   605,   608,   612,   616,   620,
   624,   628,   632,   635,   639,   644,   649,   656,   661,   666,
   671,   678,   685,   690,   695,   699,   703,   707,   711,   715,
   719,   723,   727,   731
};

static const short yyrhs[] = {   135,
     0,   133,     0,   135,   134,   135,     0,   154,     0,   134,
   136,   154,     0,     0,   136,     0,   123,     0,   136,   123,
     0,     4,   124,   151,     0,     4,   125,   124,   151,     0,
    14,     0,    15,     0,    16,     0,    17,     0,     7,     0,
   109,   146,     0,    84,   146,     0,     0,    83,   138,     8,
     0,    77,     6,     0,     0,     0,    77,     6,    78,   139,
     8,   140,   150,     0,     0,     0,    77,    78,   141,     8,
   142,   150,     0,     0,    87,     4,   124,   175,    31,   175,
   153,    88,   143,     8,     0,   148,     0,     0,   148,    90,
   144,     8,     0,   145,     0,   102,     0,   102,     4,     0,
   145,     4,     0,   145,   113,     4,     0,   147,     0,   146,
   147,     0,   175,     0,   160,     0,   162,     0,     0,    89,
   151,    35,   149,     8,     0,     0,   103,     6,     0,   175,
     0,   152,     0,   160,    94,   160,     0,   160,    93,   160,
     0,   152,    91,   152,     0,   152,    91,   175,     0,   175,
    91,   152,     0,   152,    92,   152,     0,   152,    92,   175,
     0,   175,    92,   152,     0,   121,   152,     0,     0,    34,
   175,     0,    34,   118,   175,     0,   158,     0,     3,   125,
   135,   154,     0,     3,   125,   135,   163,     0,     3,   125,
   135,   166,     0,     0,     0,   126,   155,   133,   127,   156,
   157,     0,   137,     0,     0,   154,     0,    18,     0,    19,
     0,    20,     0,    21,     0,    22,     0,    23,     0,    24,
     0,    25,     0,   160,     0,   104,   175,     0,   104,   175,
   160,     0,     0,   128,   159,   133,   129,     0,   158,    26,
   175,     0,   158,    27,   175,     0,   158,    28,   175,     0,
   158,    29,   175,     0,   158,   175,     0,   158,    14,     0,
   158,    14,   175,     0,   158,    15,     0,   158,    15,   175,
     0,   158,    17,     0,   158,    17,   175,     0,   158,    16,
     0,   158,    16,   175,     0,   158,    30,   162,     0,   158,
    31,   162,     0,   158,    32,   162,     0,   158,    33,   173,
     0,   158,    34,   165,     0,   158,    35,     0,   158,    36,
     0,   158,    36,   175,     0,   158,    37,     0,   158,    37,
   175,     0,   158,   106,     0,   158,   106,   175,     0,   158,
    38,     0,   158,    38,   175,     0,   158,    39,     0,   158,
    40,     0,   158,    10,     0,   158,    11,     0,   158,    12,
     0,   158,    85,     0,   158,    86,     0,   158,   160,     0,
   158,    41,     0,   158,    42,     0,   158,    43,     0,   158,
    44,     0,   158,   105,   175,     0,   158,   107,     0,     6,
     0,   108,   112,     6,   161,   130,     0,     0,   161,   113,
   175,     0,   163,     0,   166,     0,   165,     0,   162,   116,
   165,     0,   162,   117,   165,     0,   112,   162,   113,   162,
   130,     0,   175,   164,   162,    49,   162,     0,   175,   114,
   162,   113,   162,   115,     0,    48,     0,    45,    46,    47,
    48,     0,   175,   113,   175,     0,   112,   165,   130,     0,
   167,     0,   167,   174,     0,   174,   167,     0,   174,    45,
   167,     0,    50,     0,     3,     0,   169,     0,   167,   131,
     3,     0,    13,     0,     9,    13,     0,     9,   170,     0,
   168,   170,     0,    18,     0,    19,     0,    20,     0,    21,
     0,    22,     0,    23,     0,    25,     0,   128,   129,     0,
     6,     0,   131,     3,     0,   171,   131,     3,     0,   174,
     0,   171,     0,   171,   174,     0,   172,     0,     9,    13,
   170,   172,     0,    13,   170,   172,     0,     9,   170,   172,
     0,     3,   172,     0,    51,     0,    52,     0,    53,     0,
    54,     0,    55,     0,    56,     0,    57,     0,    58,     0,
    59,     0,    60,     0,    61,     0,    79,     0,    80,     0,
    16,     0,    17,     0,    81,    16,     0,    82,    16,     0,
    81,    17,     0,    82,    17,     0,    97,     0,    98,     0,
    81,    97,     0,    82,    97,     0,    81,    98,     0,    82,
    98,     0,    99,     0,   101,     0,   100,     0,     4,     0,
     5,     0,   166,    62,     0,   166,    63,     0,   166,    64,
     0,   166,    65,     0,   166,    66,     0,   175,   116,   175,
     0,   175,   117,   175,     0,   175,   118,   175,     0,   175,
   119,   175,     0,   175,   120,   175,     0,   175,   122,   175,
     0,   117,   175,     0,   112,   151,   130,     0,    67,   112,
   151,   130,     0,    68,   112,   151,   130,     0,    69,   112,
   151,   113,   151,   130,     0,    70,   112,   151,   130,     0,
    71,   112,   151,   130,     0,    72,   112,   151,   130,     0,
    73,   112,   151,   113,   151,   130,     0,    74,   112,   151,
   113,   151,   130,     0,    75,   112,   151,   130,     0,    76,
   112,   151,   130,     0,    76,   112,   130,     0,   175,   114,
   175,     0,   175,    95,   175,     0,   175,   115,   175,     0,
   175,    96,   175,     0,   175,    94,   175,     0,   175,    93,
   175,     0,   175,    91,   175,     0,   175,    92,   175,     0,
   121,   175,     0
};

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   269,   271,   279,   284,   287,   291,   293,   296,   298,   301,
   307,   319,   321,   323,   325,   327,   332,   337,   342,   345,
   350,   357,   360,   362,   370,   373,   375,   382,   385,   391,
   399,   402,   413,   414,   418,   421,   423,   427,   430,   448,
   456,   458,   466,   470,   473,   476,   480,   483,   487,   494,
   500,   502,   504,   506,   508,   510,   512,   517,   520,   522,
   526,   541,   543,   551,   557,   563,   570,   573,   581,   584,
   588,   593,   597,   601,   606,   613,   620,   627,   634,   639,
   644,   651,   666,   678,   684,   690,   696,   702,   721,   728,
   735,   742,   749,   756,   763,   770,   777,   784,   799,   811,
   817,   824,   836,   842,   848,   854,   860,   865,   871,   887,
   904,   909,   914,   919,   924,   929,   934,   939,   946,   955,
   964,   973,   982,   988,   995,  1000,  1010,  1017,  1038,  1041,
  1049,  1052,  1057,  1062,  1067,  1072,  1079,  1081,  1084,  1087,
  1091,  1094,  1100,  1106,  1112,  1120,  1131,  1135,  1143,  1146,
  1150,  1165,  1181,  1184,  1186,  1188,  1190,  1192,  1194,  1196,
  1198,  1202,  1207,  1214,  1222,  1226,  1233,  1239,  1245,  1251,
  1257,  1265,  1268,  1270,  1272,  1274,  1276,  1278,  1280,  1282,
  1284,  1286,  1288,  1290,  1292,  1294,  1296,  1298,  1300,  1302,
  1304,  1306,  1308,  1310,  1312,  1314,  1316,  1318,  1320,  1324,
  1333,  1335,  1342,  1349,  1356,  1363,  1370,  1372,  1374,  1376,
  1384,  1392,  1405,  1407,  1409,  1418,  1427,  1440,  1449,  1458,
  1467,  1469,  1471,  1473,  1475,  1481,  1483,  1485,  1487,  1489,
  1491,  1493,  1495,  1497
};

static const char * const yytname[] = {   "$",
"error","$illegal.","LABEL","VARIABLE","NUMBER","TEXT","COMMAND_LINE","DELIMITED","ORDINAL","LEFT_ARROW_HEAD",
"RIGHT_ARROW_HEAD","DOUBLE_ARROW_HEAD","LAST","UP","DOWN","LEFT","RIGHT","BOX","CIRCLE","ELLIPSE",
"ARC","LINE","ARROW","MOVE","SPLINE","HEIGHT","RADIUS","WIDTH","DIAMETER","FROM",
"TO","AT","WITH","BY","THEN","DOTTED","DASHED","CHOP","SAME","INVISIBLE",
"LJUST","RJUST","ABOVE","BELOW","OF","THE","WAY","BETWEEN","AND","HERE",
"DOT_N","DOT_E","DOT_W","DOT_S","DOT_NE","DOT_SE","DOT_NW","DOT_SW","DOT_C","DOT_START",
"DOT_END","DOT_X","DOT_Y","DOT_HT","DOT_WID","DOT_RAD","SIN","COS","ATAN2","LOG",
"EXP","SQRT","MAX","MIN","INT","RAND","COPY","THRU","TOP","BOTTOM",
"UPPER","LOWER","SH","PRINT","CW","CCW","FOR","DO","IF","ELSE",
"ANDAND","OROR","NOTEQUAL","EQUALEQUAL","LESSEQUAL","GREATEREQUAL","LEFT_CORNER","RIGHT_CORNER","CENTER","END",
"START","RESET","UNTIL","PLOT","THICKNESS","FILL","ALIGNED","SPRINTF","COMMAND","DEFINE",
"UNDEF","'('","','","'<'","'>'","'+'","'-'","'*'","'/'","'%'",
"'!'","'^'","';'","'='","':'","'{'","'}'","'['","']'","')'",
"'.'","top","element_list","middle_element_list","optional_separator","separator","placeless_element","@1","@2","@3",
"@4","@5","@6","@7","reset_variables","print_args","print_arg","simple_if","@8","until",
"any_expr","text_expr","optional_by","element","@9","@10","optional_element","object_spec","@11","text",
"sprintf_args","position","position_not_place","between","expr_pair","place","label","optional_ordinal_last","nth_primitive","object_type",
"label_path","relative_path","path","corner","expr",""
};
#endif

static const short yyr1[] = {     0,
   132,   132,   133,   134,   134,   135,   135,   136,   136,   137,
   137,   137,   137,   137,   137,   137,   137,   137,   138,   137,
   137,   139,   140,   137,   141,   142,   137,   143,   137,   137,
   144,   137,   137,   137,   145,   145,   145,   146,   146,   147,
   147,   147,   149,   148,   150,   150,   151,   151,   152,   152,
   152,   152,   152,   152,   152,   152,   152,   153,   153,   153,
   154,   154,   154,   154,   155,   156,   154,   154,   157,   157,
   158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
   158,   159,   158,   158,   158,   158,   158,   158,   158,   158,
   158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
   158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
   158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
   158,   158,   158,   158,   160,   160,   161,   161,   162,   162,
   163,   163,   163,   163,   163,   163,   164,   164,   165,   165,
   166,   166,   166,   166,   166,   167,   167,   167,   168,   168,
   169,   169,   170,   170,   170,   170,   170,   170,   170,   170,
   170,   171,   171,   172,   172,   172,   173,   173,   173,   173,
   173,   174,   174,   174,   174,   174,   174,   174,   174,   174,
   174,   174,   174,   174,   174,   174,   174,   174,   174,   174,
   174,   174,   174,   174,   174,   174,   174,   174,   174,   175,
   175,   175,   175,   175,   175,   175,   175,   175,   175,   175,
   175,   175,   175,   175,   175,   175,   175,   175,   175,   175,
   175,   175,   175,   175,   175,   175,   175,   175,   175,   175,
   175,   175,   175,   175
};

static const short yyr2[] = {     0,
     1,     1,     3,     1,     3,     0,     1,     1,     2,     3,
     4,     1,     1,     1,     1,     1,     2,     2,     0,     3,
     2,     0,     0,     7,     0,     0,     6,     0,    10,     1,
     0,     4,     1,     1,     2,     2,     3,     1,     2,     1,
     1,     1,     0,     5,     0,     2,     1,     1,     3,     3,
     3,     3,     3,     3,     3,     3,     2,     0,     2,     3,
     1,     4,     4,     4,     0,     0,     6,     1,     0,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
     3,     0,     4,     3,     3,     3,     3,     2,     2,     3,
     2,     3,     2,     3,     2,     3,     3,     3,     3,     3,
     3,     2,     2,     3,     2,     3,     2,     3,     2,     3,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     3,     2,     1,     5,     0,     3,     1,     1,
     1,     3,     3,     5,     5,     6,     1,     4,     3,     3,
     1,     2,     2,     3,     1,     1,     1,     3,     1,     2,
     2,     2,     1,     1,     1,     1,     1,     1,     1,     2,
     1,     2,     3,     1,     1,     2,     1,     4,     3,     3,
     2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     2,     2,     2,     2,
     1,     1,     2,     2,     2,     2,     1,     1,     1,     1,
     1,     2,     2,     2,     2,     2,     3,     3,     3,     3,
     3,     3,     2,     3,     4,     4,     6,     4,     4,     4,
     6,     6,     4,     4,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     2
};

static const short yydefact[] = {     6,
     8,     2,     1,     7,     0,     0,   125,    16,    12,    13,
    14,    15,    71,    72,    73,    74,    75,    76,    77,    78,
     0,    19,     0,     0,     0,    34,     0,     0,     0,    65,
    82,     6,    68,    33,    30,     4,    61,    79,     9,     6,
     0,     0,    21,    25,     0,   146,   200,   201,     0,   149,
   185,   186,   145,   172,   173,   174,   175,   176,   177,   178,
   179,   180,   181,   182,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   183,   184,     0,     0,   191,   192,
   197,   199,   198,     0,     0,     0,    18,    38,    41,    42,
   129,   131,   130,   141,     0,   147,     0,    40,     0,     0,
     0,     0,    48,     0,     0,    47,    35,    80,     0,    17,
     6,     6,     3,     7,    36,     0,    31,   113,   114,   115,
    89,    91,    95,    93,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   102,   103,   105,   109,   111,   112,   119,
   120,   121,   122,   116,   117,     0,   107,   124,   118,    88,
     0,    10,     0,    22,     0,    20,   161,   150,   153,   154,
   155,   156,   157,   158,   159,     0,   151,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   187,   189,   193,
   195,   188,   190,   194,   196,     0,     0,   131,    47,   213,
   234,    39,     0,     0,   202,   203,   204,   205,   206,     0,
   142,   152,     0,   143,     0,   137,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    57,   234,    43,     0,     0,     0,     0,
     0,     0,     0,    81,   127,     0,     0,     0,     5,    37,
     0,    90,    92,    96,    94,    84,    85,    86,    87,    97,
     0,    98,    99,     0,     0,     0,     0,   165,   167,   100,
   164,     0,   101,     0,   104,   106,   110,   123,   108,   146,
   200,    14,    15,    62,     0,    63,    64,    11,     0,    26,
   160,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   225,     0,   214,     0,   140,   132,   133,   148,   144,     0,
   232,   233,   231,   230,   227,   229,   139,     0,   226,   228,
   207,   208,   209,   210,   211,   212,     0,     0,     0,    51,
    52,    54,    55,    50,    49,    53,   232,    56,   233,   226,
     0,    66,    83,    32,   171,     0,     0,     0,   162,     0,
   166,     0,    47,    23,    45,   215,   216,     0,   218,   219,
   220,     0,     0,   223,   224,     0,     0,     0,     0,     0,
    44,     0,   126,    69,     0,   170,   169,   163,    45,     0,
    27,     0,     0,     0,   134,   138,     0,   135,    58,   128,
    70,    67,   168,    24,    46,   217,   221,   222,   136,     0,
     0,     0,    59,    28,    60,     0,    29,     0,     0,     0
};

static const short yydefgoto[] = {   398,
     2,    32,   237,     4,    33,    45,   279,   369,   155,   345,
   396,   241,    34,    87,    88,    35,   319,   371,   186,   103,
   391,    36,   111,   364,   382,    37,   112,   104,   331,    90,
    91,   222,    92,   105,    94,    95,    96,   167,   258,   259,
   260,    97,   106
};

static const short yypact[] = {   -98,
-32768,-32768,   615,   -95,   -79,  -102,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
    13,-32768,   832,    61,   942,    73,  1370,   -20,   832,-32768,
-32768,   -98,-32768,     5,    -6,-32768,   722,-32768,-32768,   -98,
   942,   -29,    33,-32768,   112,-32768,-32768,-32768,    32,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,    10,    29,    47,    49,    52,    53,
    54,    60,    68,    70,-32768,-32768,    -1,    58,-32768,-32768,
-32768,-32768,-32768,  1052,  1370,  1370,   832,-32768,-32768,   -77,
-32768,-32768,   321,  1949,   156,-32768,   198,  1979,    59,   942,
   942,    90,   -59,   -11,   321,   869,-32768,   284,   167,   832,
   -98,   -98,-32768,   592,-32768,   199,-32768,-32768,-32768,-32768,
  1814,  1814,  1654,  1734,  1370,  1370,  1370,  1370,  1472,  1472,
  1472,   251,  1574,-32768,  1814,  1814,  1814,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,  1370,  1814,-32768,-32768,   979,
   476,-32768,   942,-32768,   205,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,    77,-32768,   942,   942,   942,
   942,   942,   942,   942,   942,   942,   357,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,    84,   -57,    87,  1995,    96,
    96,-32768,  1574,  1574,-32768,-32768,-32768,-32768,-32768,   216,
-32768,-32768,    18,    92,   178,-32768,  1370,  1370,  1370,  1370,
  1370,  1370,  1370,  1472,  1370,  1370,  1370,  1370,  1370,  1370,
  1370,  1472,  1370,-32768,    96,-32768,   942,   942,     1,     1,
   942,   942,  1370,-32768,-32768,   100,   615,   101,-32768,-32768,
   221,   979,   979,   979,   979,   979,   979,   979,   979,   -77,
  1979,   -77,   -77,  1885,   260,   156,   229,  1938,-32768,-32768,
-32768,  1162,-32768,   569,   979,   979,   979,   979,   979,   -79,
  -102,   212,   213,-32768,   -77,   -28,   331,-32768,   225,-32768,
-32768,   104,   105,   125,   110,   111,   115,   129,   135,   120,
-32768,   121,-32768,  1472,-32768,-32768,-32768,-32768,    92,   206,
   801,  1089,   911,   911,   237,   237,   979,   -37,   224,   237,
   143,   143,    96,    96,    96,    96,   -31,   200,   244,-32768,
   801,   165,  1191,-32768,-32768,-32768,   801,   165,  1191,   237,
   -93,-32768,-32768,-32768,-32768,   156,  1885,  1885,-32768,   256,
-32768,    87,   759,-32768,   172,-32768,-32768,   942,-32768,-32768,
-32768,   942,   942,-32768,-32768,   -49,   222,  1472,  1472,  1370,
-32768,  1370,-32768,   615,  1885,-32768,-32768,-32768,   172,   280,
-32768,   157,   158,   159,-32768,-32768,   -45,   -77,   532,   979,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  1264,
   209,  1370,   979,-32768,   979,   290,-32768,   299,   301,-32768
};

static const short yypgoto[] = {-32768,
    19,-32768,    26,   281,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   292,   -76,-32768,-32768,   -46,   -24,   -89,
-32768,  -109,-32768,-32768,-32768,-32768,-32768,     7,-32768,   -82,
   174,-32768,   -60,     6,   -84,-32768,-32768,   -87,-32768,  -211,
-32768,   -91,   -23
};


#define	YYLAST		2117


static const short yytable[] = {    98,
   102,   187,   201,   108,   239,    98,     7,   202,   115,    38,
   192,   224,   204,   150,   178,   179,   152,   359,    43,   362,
    46,    41,    42,   188,     1,     3,    49,    39,    93,    89,
    50,   227,   228,   192,    93,    89,   363,   157,   193,   194,
   261,   274,   335,   149,   158,    40,   250,   252,   253,   159,
   160,   161,   162,   163,   164,   294,   165,   113,   193,   194,
   189,   190,   191,    98,    99,   151,   193,   194,   275,   389,
   193,   194,   263,   182,   183,   358,   107,   225,   193,   194,
   375,   229,   230,   117,   193,   194,    98,  -129,  -129,    93,
    44,   109,    93,    89,   153,   180,   181,   242,   243,   244,
   245,   246,   247,   248,   249,   251,   251,   251,    28,   264,
   154,   265,   266,   267,   234,    93,    89,   116,   299,   156,
    38,   168,   268,   269,   226,   366,   367,   251,   278,   236,
   238,   308,   296,   297,    93,    93,    93,   320,   322,   317,
   169,   326,   328,   282,   283,   284,   285,   286,   287,   288,
   289,   290,   292,   383,   184,   185,   277,    38,   170,   166,
   171,   157,   261,   172,   173,   174,   341,   337,   338,   264,
   264,   175,   235,   159,   160,   161,   162,   163,   164,   176,
   165,   177,   223,   301,   302,   303,   304,   305,   306,   307,
   309,   310,   311,   312,   313,   314,   315,   316,   251,   318,
    46,   342,   240,   321,   323,   281,    49,   327,   329,   330,
    50,   356,   280,   293,  -185,  -186,   295,   221,   298,    93,
  -185,  -186,   200,   300,  -185,  -186,   332,    93,   334,   333,
   360,   339,   344,   346,   347,   324,   325,   348,   343,   349,
   350,   352,   203,    38,   351,   261,   261,   353,   365,   354,
   355,   361,   357,   254,   381,   227,  -185,  -186,   368,   255,
   218,   219,   220,   256,   221,   157,    51,    52,   205,   376,
   251,   206,   336,   261,   370,   377,   378,   159,   160,   161,
   162,   163,   164,   166,   165,   385,   386,   387,   388,     7,
   207,   208,   209,   210,   211,   212,   394,   397,   399,    93,
   400,    54,    55,    56,    57,    58,    59,    60,    61,    62,
    63,    64,   114,   233,   215,   216,   217,   218,   219,   220,
   110,   221,   384,   372,   276,     0,     0,   373,   374,    75,
    76,    77,    78,     0,   251,   251,   379,     0,   380,   216,
   217,   218,   219,   220,     0,   221,     0,    79,    80,    81,
    82,    83,   216,   217,   218,   219,   220,     0,   221,    46,
    47,    48,     7,    93,    93,    49,   393,     0,   395,    50,
    38,     0,    51,    52,   207,   208,   209,   210,   211,   212,
     0,   257,   195,   196,   197,   198,   199,   166,     0,     0,
     0,    28,   195,   196,   197,   198,   199,   233,   215,   216,
   217,   218,   219,   220,     0,   221,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,     0,     0,
     0,     0,     0,    65,    66,    67,    68,    69,    70,    71,
    72,    73,    74,     0,     0,    75,    76,    77,    78,     0,
     0,     0,     0,     0,     0,     0,  -130,  -130,     0,     0,
     0,     0,     0,    79,    80,    81,    82,    83,     0,     0,
     0,     0,     0,     0,    28,     0,     0,     0,   100,     0,
     0,     0,     0,    85,     0,     0,     0,   101,   270,   271,
    48,     7,     8,     0,    49,     0,   291,     0,    50,     9,
    10,   272,   273,    13,    14,    15,    16,    17,    18,    19,
    20,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    53,    54,    55,    56,    57,
    58,    59,    60,    61,    62,    63,    64,     0,     0,     0,
     0,     0,    65,    66,    67,    68,    69,    70,    71,    72,
    73,    74,    21,     0,    75,    76,    77,    78,    22,    23,
     0,     0,    24,     0,    25,   390,     0,     0,     0,     0,
     0,     0,    79,    80,    81,    82,    83,    26,     0,    27,
     0,     0,     0,    28,    29,     0,     0,    84,     0,     0,
     0,     0,    85,     0,     5,     6,    86,     7,     8,     0,
     0,    30,     0,    31,     0,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,     5,     6,     0,
     7,     8,   207,   208,   209,   210,   211,   212,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
     0,     0,     0,     0,     0,   233,   215,   216,   217,   218,
   219,   220,     0,   221,     0,     0,     0,     0,     0,   207,
   208,   209,   210,   211,   212,     0,     0,     0,    21,     0,
     0,     0,     0,     0,    22,    23,     0,     0,    24,     0,
    25,   213,   233,   215,   216,   217,   218,   219,   220,     0,
   221,    21,     0,    26,     0,    27,     0,    22,    23,    28,
    29,    24,     0,    25,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    39,     0,    26,    30,    27,    31,
     0,     0,    28,    29,    46,    47,    48,     7,     0,     0,
    49,   118,   119,   120,    50,   121,   122,   123,   124,     0,
    30,     0,    31,     0,     0,     0,     0,   125,   126,   127,
   128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
   138,   139,   140,   141,   142,   143,     0,     0,     0,     0,
     0,    53,    54,    55,    56,    57,    58,    59,    60,    61,
    62,    63,    64,     0,     0,     0,     0,     0,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,     0,     0,
    75,    76,    77,    78,     0,     0,   144,   145,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    79,    80,
    81,    82,    83,     0,     0,     0,   146,   147,   148,    28,
     0,     0,     0,   100,    46,    47,    48,     7,    85,     0,
    49,     0,    86,     0,    50,     0,     0,    51,    52,   231,
   232,   209,   210,   211,   212,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   213,   233,   215,   216,   217,   218,   219,   220,     0,
   221,    53,    54,    55,    56,    57,    58,    59,    60,    61,
    62,    63,    64,   209,   210,   211,   212,     0,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,     0,     0,
    75,    76,    77,    78,   233,   215,   216,   217,   218,   219,
   220,     0,   221,     0,     0,     0,     0,     0,    79,    80,
    81,    82,    83,     0,     0,     0,     0,     0,     0,    28,
     0,     0,     0,    84,    46,    47,    48,     7,    85,     0,
    49,     0,    86,     0,    50,     0,     0,    51,    52,   231,
   232,   209,   210,   211,   212,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   233,   215,   216,   217,   218,   219,   220,     0,
   221,    53,    54,    55,    56,    57,    58,    59,    60,    61,
    62,    63,    64,     0,     0,   211,   212,     0,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,     0,     0,
    75,    76,    77,    78,   233,   215,   216,   217,   218,   219,
   220,     0,   221,     0,     0,     0,     0,     0,    79,    80,
    81,    82,    83,     0,     0,     0,     0,     0,     0,    28,
     0,     0,     0,   100,    46,    47,    48,     7,    85,     0,
    49,     0,   101,     0,    50,     0,     0,    51,    52,   207,
   208,   209,   210,   211,   212,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   233,   215,   216,   217,   218,   219,   220,     0,
   221,    53,    54,    55,    56,    57,    58,    59,    60,    61,
    62,    63,    64,     0,     0,     0,     0,     0,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,     0,     0,
    75,    76,    77,    78,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    79,    80,
    81,    82,    83,     0,     0,     0,     0,     0,     0,    28,
     0,     0,     0,    84,    46,    47,    48,     7,    85,     0,
    49,     0,   101,     0,    50,     0,     0,    51,    52,   207,
     0,   209,   210,   211,   212,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   233,   215,   216,   217,   218,   219,   220,     0,
   221,    53,    54,    55,    56,    57,    58,    59,    60,    61,
    62,    63,    64,     0,     0,     0,     0,     0,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,     0,     0,
    75,    76,    77,    78,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    79,    80,
    81,    82,    83,     0,     0,     0,    46,    47,    48,    28,
     0,     0,    49,   262,     0,     0,    50,     0,    85,    51,
    52,   231,   101,   209,   210,   211,   212,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   233,   215,   216,   217,   218,   219,
   220,     0,   221,    53,    54,    55,    56,    57,    58,    59,
    60,    61,    62,    63,    64,     0,     0,     0,     0,     0,
    65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
     0,     0,    75,    76,    77,    78,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    79,    80,    81,    82,    83,     0,     0,     0,     0,     0,
     0,     0,    46,    47,    48,   100,     0,     0,    49,     0,
    85,   392,    50,     0,    86,    51,    52,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    53,
    54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
    64,     0,     0,     0,     0,     0,    65,    66,    67,    68,
    69,    70,    71,    72,    73,    74,     0,     0,    75,    76,
    77,    78,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    79,    80,    81,    82,
    83,     0,     0,     0,    46,    47,    48,     0,     0,     0,
    49,   100,     0,     0,    50,     0,    85,    51,    52,     0,
    86,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    53,    54,    55,    56,    57,    58,    59,    60,    61,
    62,    63,    64,     0,     0,     0,     0,     0,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,     0,     0,
    75,    76,    77,    78,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    79,    80,
    81,    82,    83,     0,     0,     0,    46,    47,    48,     0,
     0,     0,    49,    84,     0,     0,    50,     0,    85,    51,
    52,     0,    86,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    53,    54,    55,    56,    57,    58,    59,
    60,    61,    62,    63,    64,     0,     0,     0,     0,     0,
    65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
     0,     0,    75,    76,    77,    78,    46,    47,    48,     0,
     0,     0,    49,     0,     0,     0,    50,     0,     0,     0,
    79,    80,    81,    82,    83,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   262,     0,     0,     0,     0,
    85,     0,     0,     0,    86,     0,     0,     0,  -185,     0,
     0,     0,     0,    53,    54,    55,    56,    57,    58,    59,
    60,    61,    62,    63,    64,     0,     0,     0,     0,     0,
    65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
     0,     0,    75,    76,    77,    78,    46,    47,    48,     0,
     0,     0,    49,     0,     0,     0,    50,     0,     0,     0,
    79,    80,    81,    82,    83,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   100,     0,     0,     0,     0,
    85,     0,     0,     0,    86,     0,     0,     0,  -186,     0,
     0,     0,     0,    53,    54,    55,    56,    57,    58,    59,
    60,    61,    62,    63,    64,     0,     0,     0,     0,     0,
    65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
     0,     0,    75,    76,    77,    78,    46,    47,    48,     0,
     0,     0,    49,     0,     0,     0,    50,     0,     0,     0,
    79,    80,    81,    82,    83,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   100,     0,     0,     0,     0,
    85,     0,     0,     0,    86,     0,     0,     0,     0,     0,
     0,     0,     0,    53,    54,    55,    56,    57,    58,    59,
    60,    61,    62,    63,    64,     0,     0,     0,     0,     0,
    65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
     0,     0,    75,    76,    77,    78,     0,     0,     0,     0,
    51,    52,     0,     0,     0,     0,     0,     0,     0,     0,
    79,    80,    81,    82,    83,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   100,     0,     0,     0,     0,
    85,     0,     0,     0,    86,    54,    55,    56,    57,    58,
    59,    60,    61,    62,    63,    64,     0,     0,     0,     0,
     0,     0,     0,    51,    52,     0,     0,     0,     0,     0,
     0,     0,     0,    75,    76,    77,    78,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    79,    80,    81,    82,    83,     0,     0,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    54,
    55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
     0,     0,     0,     0,     0,   257,    75,    76,    77,    78,
     0,     0,     0,   205,     0,     0,   206,    75,    76,    77,
    78,     0,     0,     0,    79,    80,    81,    82,    83,   205,
     0,     0,   206,     0,     0,    79,    80,    81,    82,    83,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   340,   207,
   208,   209,   210,   211,   212,     0,     0,     0,     0,   200,
     0,     0,     0,     0,     0,   231,   232,   209,   210,   211,
   212,   213,   214,   215,   216,   217,   218,   219,   220,     0,
   221,     0,     0,     0,     0,     0,     0,   213,   214,   215,
   216,   217,   218,   219,   220,     0,   221
};

static const short yycheck[] = {    23,
    25,    84,    94,    27,   114,    29,     6,    95,     4,     3,
    87,   101,    97,    37,    16,    17,    41,    49,     6,   113,
     3,   124,   125,    84,   123,     0,     9,   123,    23,    23,
    13,    91,    92,   110,    29,    29,   130,     6,   116,   117,
   132,   151,   254,    37,    13,   125,   129,   130,   131,    18,
    19,    20,    21,    22,    23,   113,    25,    32,   116,   117,
    84,    85,    86,    87,     4,    40,   116,   117,   151,   115,
   116,   117,   133,    16,    17,   113,     4,   101,   116,   117,
   130,    93,    94,    90,   116,   117,   110,   116,   117,    84,
    78,   112,    87,    87,   124,    97,    98,   121,   122,   123,
   124,   125,   126,   127,   128,   129,   130,   131,   108,   133,
    78,   135,   136,   137,   108,   110,   110,   113,   203,     8,
   114,   112,   146,   147,    35,   337,   338,   151,   153,   111,
   112,   214,   193,   194,   129,   130,   131,   227,   228,   222,
   112,   231,   232,   168,   169,   170,   171,   172,   173,   174,
   175,   176,   177,   365,    97,    98,   151,   151,   112,   128,
   112,     6,   254,   112,   112,   112,   258,   255,   256,   193,
   194,   112,     6,    18,    19,    20,    21,    22,    23,   112,
    25,   112,   124,   207,   208,   209,   210,   211,   212,   213,
   214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     3,   262,     4,   227,   228,   129,     9,   231,   232,   233,
    13,   294,     8,   130,     3,     3,   130,   122,     3,   214,
     9,     9,   131,    46,    13,    13,   127,   222,     8,   129,
    31,     3,     8,   130,   130,   229,   230,   113,   262,   130,
   130,   113,    45,   237,   130,   337,   338,   113,   336,   130,
   130,     8,    47,     3,   364,    91,    45,    45,     3,     9,
   118,   119,   120,    13,   122,     6,    16,    17,    45,    48,
   294,    48,    13,   365,   103,   358,   359,    18,    19,    20,
    21,    22,    23,   128,    25,     6,   130,   130,   130,     6,
    91,    92,    93,    94,    95,    96,    88,     8,     0,   294,
     0,    51,    52,    53,    54,    55,    56,    57,    58,    59,
    60,    61,    32,   114,   115,   116,   117,   118,   119,   120,
    29,   122,   369,   348,   151,    -1,    -1,   352,   353,    79,
    80,    81,    82,    -1,   358,   359,   360,    -1,   362,   116,
   117,   118,   119,   120,    -1,   122,    -1,    97,    98,    99,
   100,   101,   116,   117,   118,   119,   120,    -1,   122,     3,
     4,     5,     6,   358,   359,     9,   390,    -1,   392,    13,
   364,    -1,    16,    17,    91,    92,    93,    94,    95,    96,
    -1,   131,    62,    63,    64,    65,    66,   128,    -1,    -1,
    -1,   108,    62,    63,    64,    65,    66,   114,   115,   116,
   117,   118,   119,   120,    -1,   122,    50,    51,    52,    53,
    54,    55,    56,    57,    58,    59,    60,    61,    -1,    -1,
    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
    74,    75,    76,    -1,    -1,    79,    80,    81,    82,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,   116,   117,    -1,    -1,
    -1,    -1,    -1,    97,    98,    99,   100,   101,    -1,    -1,
    -1,    -1,    -1,    -1,   108,    -1,    -1,    -1,   112,    -1,
    -1,    -1,    -1,   117,    -1,    -1,    -1,   121,     3,     4,
     5,     6,     7,    -1,     9,    -1,   130,    -1,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    50,    51,    52,    53,    54,
    55,    56,    57,    58,    59,    60,    61,    -1,    -1,    -1,
    -1,    -1,    67,    68,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    -1,    79,    80,    81,    82,    83,    84,
    -1,    -1,    87,    -1,    89,    34,    -1,    -1,    -1,    -1,
    -1,    -1,    97,    98,    99,   100,   101,   102,    -1,   104,
    -1,    -1,    -1,   108,   109,    -1,    -1,   112,    -1,    -1,
    -1,    -1,   117,    -1,     3,     4,   121,     6,     7,    -1,
    -1,   126,    -1,   128,    -1,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    24,    25,     3,     4,    -1,
     6,     7,    91,    92,    93,    94,    95,    96,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    -1,    -1,    -1,    -1,    -1,   114,   115,   116,   117,   118,
   119,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    91,
    92,    93,    94,    95,    96,    -1,    -1,    -1,    77,    -1,
    -1,    -1,    -1,    -1,    83,    84,    -1,    -1,    87,    -1,
    89,   113,   114,   115,   116,   117,   118,   119,   120,    -1,
   122,    77,    -1,   102,    -1,   104,    -1,    83,    84,   108,
   109,    87,    -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   123,    -1,   102,   126,   104,   128,
    -1,    -1,   108,   109,     3,     4,     5,     6,    -1,    -1,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    -1,
   126,    -1,   128,    -1,    -1,    -1,    -1,    26,    27,    28,
    29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
    39,    40,    41,    42,    43,    44,    -1,    -1,    -1,    -1,
    -1,    50,    51,    52,    53,    54,    55,    56,    57,    58,
    59,    60,    61,    -1,    -1,    -1,    -1,    -1,    67,    68,
    69,    70,    71,    72,    73,    74,    75,    76,    -1,    -1,
    79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,    98,
    99,   100,   101,    -1,    -1,    -1,   105,   106,   107,   108,
    -1,    -1,    -1,   112,     3,     4,     5,     6,   117,    -1,
     9,    -1,   121,    -1,    13,    -1,    -1,    16,    17,    91,
    92,    93,    94,    95,    96,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,   113,   114,   115,   116,   117,   118,   119,   120,    -1,
   122,    50,    51,    52,    53,    54,    55,    56,    57,    58,
    59,    60,    61,    93,    94,    95,    96,    -1,    67,    68,
    69,    70,    71,    72,    73,    74,    75,    76,    -1,    -1,
    79,    80,    81,    82,   114,   115,   116,   117,   118,   119,
   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    97,    98,
    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,   108,
    -1,    -1,    -1,   112,     3,     4,     5,     6,   117,    -1,
     9,    -1,   121,    -1,    13,    -1,    -1,    16,    17,    91,
    92,    93,    94,    95,    96,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,   114,   115,   116,   117,   118,   119,   120,    -1,
   122,    50,    51,    52,    53,    54,    55,    56,    57,    58,
    59,    60,    61,    -1,    -1,    95,    96,    -1,    67,    68,
    69,    70,    71,    72,    73,    74,    75,    76,    -1,    -1,
    79,    80,    81,    82,   114,   115,   116,   117,   118,   119,
   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    97,    98,
    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,   108,
    -1,    -1,    -1,   112,     3,     4,     5,     6,   117,    -1,
     9,    -1,   121,    -1,    13,    -1,    -1,    16,    17,    91,
    92,    93,    94,    95,    96,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,   114,   115,   116,   117,   118,   119,   120,    -1,
   122,    50,    51,    52,    53,    54,    55,    56,    57,    58,
    59,    60,    61,    -1,    -1,    -1,    -1,    -1,    67,    68,
    69,    70,    71,    72,    73,    74,    75,    76,    -1,    -1,
    79,    80,    81,    82,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,    98,
    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,   108,
    -1,    -1,    -1,   112,     3,     4,     5,     6,   117,    -1,
     9,    -1,   121,    -1,    13,    -1,    -1,    16,    17,    91,
    -1,    93,    94,    95,    96,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,   114,   115,   116,   117,   118,   119,   120,    -1,
   122,    50,    51,    52,    53,    54,    55,    56,    57,    58,
    59,    60,    61,    -1,    -1,    -1,    -1,    -1,    67,    68,
    69,    70,    71,    72,    73,    74,    75,    76,    -1,    -1,
    79,    80,    81,    82,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,    98,
    99,   100,   101,    -1,    -1,    -1,     3,     4,     5,   108,
    -1,    -1,     9,   112,    -1,    -1,    13,    -1,   117,    16,
    17,    91,   121,    93,    94,    95,    96,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   114,   115,   116,   117,   118,   119,
   120,    -1,   122,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    -1,    -1,    79,    80,    81,    82,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    97,    98,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,     3,     4,     5,   112,    -1,    -1,     9,    -1,
   117,   118,    13,    -1,   121,    16,    17,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,
    51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
    61,    -1,    -1,    -1,    -1,    -1,    67,    68,    69,    70,
    71,    72,    73,    74,    75,    76,    -1,    -1,    79,    80,
    81,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    97,    98,    99,   100,
   101,    -1,    -1,    -1,     3,     4,     5,    -1,    -1,    -1,
     9,   112,    -1,    -1,    13,    -1,   117,    16,    17,    -1,
   121,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    50,    51,    52,    53,    54,    55,    56,    57,    58,
    59,    60,    61,    -1,    -1,    -1,    -1,    -1,    67,    68,
    69,    70,    71,    72,    73,    74,    75,    76,    -1,    -1,
    79,    80,    81,    82,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,    98,
    99,   100,   101,    -1,    -1,    -1,     3,     4,     5,    -1,
    -1,    -1,     9,   112,    -1,    -1,    13,    -1,   117,    16,
    17,    -1,   121,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    -1,    -1,    79,    80,    81,    82,     3,     4,     5,    -1,
    -1,    -1,     9,    -1,    -1,    -1,    13,    -1,    -1,    -1,
    97,    98,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,    -1,    -1,
   117,    -1,    -1,    -1,   121,    -1,    -1,    -1,    45,    -1,
    -1,    -1,    -1,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    -1,    -1,    79,    80,    81,    82,     3,     4,     5,    -1,
    -1,    -1,     9,    -1,    -1,    -1,    13,    -1,    -1,    -1,
    97,    98,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,    -1,    -1,
   117,    -1,    -1,    -1,   121,    -1,    -1,    -1,    45,    -1,
    -1,    -1,    -1,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    -1,    -1,    79,    80,    81,    82,     3,     4,     5,    -1,
    -1,    -1,     9,    -1,    -1,    -1,    13,    -1,    -1,    -1,
    97,    98,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,    -1,    -1,
   117,    -1,    -1,    -1,   121,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    -1,    -1,    79,    80,    81,    82,    -1,    -1,    -1,    -1,
    16,    17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    97,    98,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,    -1,    -1,
   117,    -1,    -1,    -1,   121,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    16,    17,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    79,    80,    81,    82,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    97,    98,    99,   100,   101,    -1,    -1,    51,    52,
    53,    54,    55,    56,    57,    58,    59,    60,    61,    51,
    52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
    -1,    -1,    -1,    -1,    -1,   131,    79,    80,    81,    82,
    -1,    -1,    -1,    45,    -1,    -1,    48,    79,    80,    81,
    82,    -1,    -1,    -1,    97,    98,    99,   100,   101,    45,
    -1,    -1,    48,    -1,    -1,    97,    98,    99,   100,   101,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   131,    91,
    92,    93,    94,    95,    96,    -1,    -1,    -1,    -1,   131,
    -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
    96,   113,   114,   115,   116,   117,   118,   119,   120,    -1,
   122,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,   115,
   116,   117,   118,   119,   120,    -1,   122
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* Not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__)
#include <alloca.h>
#else /* Not sparc */
#ifdef MSDOS
#include <malloc.h>
#endif /* MSDOS */
#endif /* Not sparc.  */
#endif /* Not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX		yylex(&yylval, &yylloc)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif

#line 160 "/usr/local/lib/bison.simple"
int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/

#define YYPOPSTACK   (yyvsp--, yysp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yysp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
#ifdef YYLSP_NEEDED
		 &yyls1, size * sizeof (*yylsp),
#endif
		 &yystacksize);

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Next token is %d (%s)\n", yychar, yytname[yychar1]);
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symboles being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 2:
#line 272 "pic.y"
{
		  if (olist.head)
		    print_picture(olist.head);
		;
    break;}
case 3:
#line 281 "pic.y"
{ yyval.pl = yyvsp[-1].pl; ;
    break;}
case 4:
#line 286 "pic.y"
{ yyval.pl = yyvsp[0].pl; ;
    break;}
case 5:
#line 288 "pic.y"
{ yyval.pl = yyvsp[-2].pl; ;
    break;}
case 10:
#line 303 "pic.y"
{
		  define_variable(yyvsp[-2].str, yyvsp[0].x);
		  a_delete yyvsp[-2].str;
		;
    break;}
case 11:
#line 308 "pic.y"
{
		  place *p = lookup_label(yyvsp[-3].str);
		  if (!p) {
		    lex_error("variable `%1' not defined", yyvsp[-3].str);
		    YYABORT;
		  }
		  p->obj = 0;
		  p->x = yyvsp[0].x;
		  p->y = 0.0;
		  a_delete yyvsp[-3].str;
		;
    break;}
case 12:
#line 320 "pic.y"
{ current_direction = UP_DIRECTION; ;
    break;}
case 13:
#line 322 "pic.y"
{ current_direction = DOWN_DIRECTION; ;
    break;}
case 14:
#line 324 "pic.y"
{ current_direction = LEFT_DIRECTION; ;
    break;}
case 15:
#line 326 "pic.y"
{ current_direction = RIGHT_DIRECTION; ;
    break;}
case 16:
#line 328 "pic.y"
{
		  olist.append(make_command_object(yyvsp[0].lstr.str, yyvsp[0].lstr.filename,
						   yyvsp[0].lstr.lineno));
		;
    break;}
case 17:
#line 333 "pic.y"
{
		  olist.append(make_command_object(yyvsp[0].lstr.str, yyvsp[0].lstr.filename,
						   yyvsp[0].lstr.lineno));
		;
    break;}
case 18:
#line 338 "pic.y"
{
		  fprintf(stderr, "%s\n", yyvsp[0].lstr.str);
	          fflush(stderr);
		;
    break;}
case 19:
#line 343 "pic.y"
{ delim_flag = 1; ;
    break;}
case 20:
#line 345 "pic.y"
{
		  delim_flag = 0;
		  system(yyvsp[0].str);
		  a_delete yyvsp[0].str;
		;
    break;}
case 21:
#line 351 "pic.y"
{
		  if (yychar < 0)
		    do_lookahead();
		  do_copy(yyvsp[0].lstr.str);
		  // do not delete the filename
		;
    break;}
case 22:
#line 358 "pic.y"
{ delim_flag = 2; ;
    break;}
case 23:
#line 360 "pic.y"
{ delim_flag = 0; ;
    break;}
case 24:
#line 362 "pic.y"
{
		  if (yychar < 0)
		    do_lookahead();
		  copy_file_thru(yyvsp[-5].lstr.str, yyvsp[-2].str, yyvsp[0].str);
		  // do not delete the filename
		  a_delete yyvsp[-2].str;
		  a_delete yyvsp[0].str;
		;
    break;}
case 25:
#line 371 "pic.y"
{ delim_flag = 2; ;
    break;}
case 26:
#line 373 "pic.y"
{ delim_flag = 0; ;
    break;}
case 27:
#line 375 "pic.y"
{
		  if (yychar < 0)
		    do_lookahead();
		  copy_rest_thru(yyvsp[-2].str, yyvsp[0].str);
		  a_delete yyvsp[-2].str;
		  a_delete yyvsp[0].str;
		;
    break;}
case 28:
#line 383 "pic.y"
{ delim_flag = 1; ;
    break;}
case 29:
#line 385 "pic.y"
{
		  delim_flag = 0;
		  if (yychar < 0)
		    do_lookahead();
		  do_for(yyvsp[-8].str, yyvsp[-6].x, yyvsp[-4].x, yyvsp[-3].by.is_multiplicative, yyvsp[-3].by.val, yyvsp[0].str);
		;
    break;}
case 30:
#line 392 "pic.y"
{
		  if (yychar < 0)
		    do_lookahead();
		  if (yyvsp[0].if_data.x != 0.0)
		    push_body(yyvsp[0].if_data.body);
		  a_delete yyvsp[0].if_data.body;
		;
    break;}
case 31:
#line 400 "pic.y"
{ delim_flag = 1; ;
    break;}
case 32:
#line 402 "pic.y"
{
		  delim_flag = 0;
		  if (yychar < 0)
		    do_lookahead();
		  if (yyvsp[-3].if_data.x != 0.0)
		    push_body(yyvsp[-3].if_data.body);
		  else
		    push_body(yyvsp[0].str);
		  a_delete yyvsp[-3].if_data.body;
		  a_delete yyvsp[0].str;
		;
    break;}
case 34:
#line 415 "pic.y"
{ define_variable("scale", 1.0); ;
    break;}
case 35:
#line 420 "pic.y"
{ reset(yyvsp[0].str); a_delete yyvsp[0].str; ;
    break;}
case 36:
#line 422 "pic.y"
{ reset(yyvsp[0].str); a_delete yyvsp[0].str; ;
    break;}
case 37:
#line 424 "pic.y"
{ reset(yyvsp[0].str); a_delete yyvsp[0].str; ;
    break;}
case 38:
#line 429 "pic.y"
{ yyval.lstr = yyvsp[0].lstr; ;
    break;}
case 39:
#line 431 "pic.y"
{
		  yyval.lstr.str = new char[strlen(yyvsp[-1].lstr.str) + strlen(yyvsp[0].lstr.str) + 1];
		  strcpy(yyval.lstr.str, yyvsp[-1].lstr.str);
		  strcat(yyval.lstr.str, yyvsp[0].lstr.str);
		  a_delete yyvsp[-1].lstr.str;
		  a_delete yyvsp[0].lstr.str;
		  if (yyvsp[-1].lstr.filename) {
		    yyval.lstr.filename = yyvsp[-1].lstr.filename;
		    yyval.lstr.lineno = yyvsp[-1].lstr.lineno;
		  }
		  else if (yyvsp[0].lstr.filename) {
		    yyval.lstr.filename = yyvsp[0].lstr.filename;
		    yyval.lstr.lineno = yyvsp[0].lstr.lineno;
		  }
		;
    break;}
case 40:
#line 450 "pic.y"
{
		  yyval.lstr.str = new char[GDIGITS + 1];
		  sprintf(yyval.lstr.str, "%g", yyvsp[0].x);
		  yyval.lstr.filename = 0;
		  yyval.lstr.lineno = 0;
		;
    break;}
case 41:
#line 457 "pic.y"
{ yyval.lstr = yyvsp[0].lstr; ;
    break;}
case 42:
#line 459 "pic.y"
{
		  yyval.lstr.str = new char[GDIGITS + 2 + GDIGITS + 1];
		  sprintf(yyval.lstr.str, "%g, %g", yyvsp[0].pair.x, yyvsp[0].pair.y);
		  yyval.lstr.filename = 0;
		  yyval.lstr.lineno = 0;
		;
    break;}
case 43:
#line 468 "pic.y"
{ delim_flag = 1; ;
    break;}
case 44:
#line 470 "pic.y"
{ delim_flag = 0; yyval.if_data.x = yyvsp[-3].x; yyval.if_data.body = yyvsp[0].str; ;
    break;}
case 45:
#line 475 "pic.y"
{ yyval.str = 0; ;
    break;}
case 46:
#line 477 "pic.y"
{ yyval.str = yyvsp[0].lstr.str; ;
    break;}
case 47:
#line 482 "pic.y"
{ yyval.x = yyvsp[0].x; ;
    break;}
case 48:
#line 484 "pic.y"
{ yyval.x = yyvsp[0].x; ;
    break;}
case 49:
#line 489 "pic.y"
{
		  yyval.x = strcmp(yyvsp[-2].lstr.str, yyvsp[0].lstr.str) == 0;
		  a_delete yyvsp[-2].lstr.str;
		  a_delete yyvsp[0].lstr.str;
		;
    break;}
case 50:
#line 495 "pic.y"
{
		  yyval.x = strcmp(yyvsp[-2].lstr.str, yyvsp[0].lstr.str) != 0;
		  a_delete yyvsp[-2].lstr.str;
		  a_delete yyvsp[0].lstr.str;
		;
    break;}
case 51:
#line 501 "pic.y"
{ yyval.x = (yyvsp[-2].x != 0.0 && yyvsp[0].x != 0.0); ;
    break;}
case 52:
#line 503 "pic.y"
{ yyval.x = (yyvsp[-2].x != 0.0 && yyvsp[0].x != 0.0); ;
    break;}
case 53:
#line 505 "pic.y"
{ yyval.x = (yyvsp[-2].x != 0.0 && yyvsp[0].x != 0.0); ;
    break;}
case 54:
#line 507 "pic.y"
{ yyval.x = (yyvsp[-2].x != 0.0 || yyvsp[0].x != 0.0); ;
    break;}
case 55:
#line 509 "pic.y"
{ yyval.x = (yyvsp[-2].x != 0.0 || yyvsp[0].x != 0.0); ;
    break;}
case 56:
#line 511 "pic.y"
{ yyval.x = (yyvsp[-2].x != 0.0 || yyvsp[0].x != 0.0); ;
    break;}
case 57:
#line 513 "pic.y"
{ yyval.x = (yyvsp[0].x == 0.0); ;
    break;}
case 58:
#line 519 "pic.y"
{ yyval.by.val = 1.0; yyval.by.is_multiplicative = 0; ;
    break;}
case 59:
#line 521 "pic.y"
{ yyval.by.val = yyvsp[0].x; yyval.by.is_multiplicative = 0; ;
    break;}
case 60:
#line 523 "pic.y"
{ yyval.by.val = yyvsp[0].x; yyval.by.is_multiplicative = 1; ;
    break;}
case 61:
#line 528 "pic.y"
{
		  yyval.pl.obj = yyvsp[0].spec->make_object(&current_position,
					   &current_direction);
		  if (yyval.pl.obj == 0)
		    YYABORT;
		  delete yyvsp[0].spec;
		  if (yyval.pl.obj)
		    olist.append(yyval.pl.obj);
		  else {
		    yyval.pl.x = current_position.x;
		    yyval.pl.y = current_position.y;
		  }
		;
    break;}
case 62:
#line 542 "pic.y"
{ yyval.pl = yyvsp[0].pl; define_label(yyvsp[-3].str, & yyval.pl); a_delete yyvsp[-3].str; ;
    break;}
case 63:
#line 544 "pic.y"
{
		  yyval.pl.obj = 0;
		  yyval.pl.x = yyvsp[0].pair.x;
		  yyval.pl.y = yyvsp[0].pair.y;
		  define_label(yyvsp[-3].str, & yyval.pl);
		  a_delete yyvsp[-3].str;
		;
    break;}
case 64:
#line 552 "pic.y"
{
		  yyval.pl = yyvsp[0].pl;
		  define_label(yyvsp[-3].str, & yyval.pl);
		  a_delete yyvsp[-3].str;
		;
    break;}
case 65:
#line 558 "pic.y"
{
		  yyval.state.x = current_position.x;
		  yyval.state.y = current_position.y;
		  yyval.state.dir = current_direction;
		;
    break;}
case 66:
#line 564 "pic.y"
{
		  current_position.x = yyvsp[-2].state.x;
		  current_position.y = yyvsp[-2].state.y;
		  current_direction = yyvsp[-2].state.dir;
		;
    break;}
case 67:
#line 570 "pic.y"
{
		  yyval.pl = yyvsp[-3].pl;
		;
    break;}
case 68:
#line 574 "pic.y"
{
		  yyval.pl.obj = 0;
		  yyval.pl.x = current_position.x;
		  yyval.pl.y = current_position.y;
		;
    break;}
case 69:
#line 583 "pic.y"
{;
    break;}
case 70:
#line 585 "pic.y"
{;
    break;}
case 71:
#line 590 "pic.y"
{
		  yyval.spec = new object_spec(BOX_OBJECT);
		;
    break;}
case 72:
#line 594 "pic.y"
{
		  yyval.spec = new object_spec(CIRCLE_OBJECT);
		;
    break;}
case 73:
#line 598 "pic.y"
{
		  yyval.spec = new object_spec(ELLIPSE_OBJECT);
		;
    break;}
case 74:
#line 602 "pic.y"
{
		  yyval.spec = new object_spec(ARC_OBJECT);
		  yyval.spec->dir = current_direction;
		;
    break;}
case 75:
#line 607 "pic.y"
{
		  yyval.spec = new object_spec(LINE_OBJECT);
		  lookup_variable("lineht", & yyval.spec->segment_height);
		  lookup_variable("linewid", & yyval.spec->segment_width);
		  yyval.spec->dir = current_direction;
		;
    break;}
case 76:
#line 614 "pic.y"
{
		  yyval.spec = new object_spec(ARROW_OBJECT);
		  lookup_variable("lineht", & yyval.spec->segment_height);
		  lookup_variable("linewid", & yyval.spec->segment_width);
		  yyval.spec->dir = current_direction;
		;
    break;}
case 77:
#line 621 "pic.y"
{
		  yyval.spec = new object_spec(MOVE_OBJECT);
		  lookup_variable("moveht", & yyval.spec->segment_height);
		  lookup_variable("movewid", & yyval.spec->segment_width);
		  yyval.spec->dir = current_direction;
		;
    break;}
case 78:
#line 628 "pic.y"
{
		  yyval.spec = new object_spec(SPLINE_OBJECT);
		  lookup_variable("lineht", & yyval.spec->segment_height);
		  lookup_variable("linewid", & yyval.spec->segment_width);
		  yyval.spec->dir = current_direction;
		;
    break;}
case 79:
#line 635 "pic.y"
{
		  yyval.spec = new object_spec(TEXT_OBJECT);
		  yyval.spec->text = new text_item(yyvsp[0].lstr.str, yyvsp[0].lstr.filename, yyvsp[0].lstr.lineno);
		;
    break;}
case 80:
#line 640 "pic.y"
{
		  yyval.spec = new object_spec(TEXT_OBJECT);
		  yyval.spec->text = new text_item(format_number(0, yyvsp[0].x), 0, -1);
		;
    break;}
case 81:
#line 645 "pic.y"
{
		  yyval.spec = new object_spec(TEXT_OBJECT);
		  yyval.spec->text = new text_item(format_number(yyvsp[0].lstr.str, yyvsp[-1].x),
					   yyvsp[0].lstr.filename, yyvsp[0].lstr.lineno);
		  a_delete yyvsp[0].lstr.str;
		;
    break;}
case 82:
#line 652 "pic.y"
{
		  saved_state *p = new saved_state;
		  yyval.pstate = p;
		  p->x = current_position.x;
		  p->y = current_position.y;
		  p->dir = current_direction;
		  p->tbl = current_table;
		  p->prev = current_saved_state;
		  current_position.x = 0.0;
		  current_position.y = 0.0;
		  current_table = new PTABLE(place);
		  current_saved_state = p;
		  olist.append(make_mark_object());
		;
    break;}
case 83:
#line 667 "pic.y"
{
		  current_position.x = yyvsp[-2].pstate->x;
		  current_position.y = yyvsp[-2].pstate->y;
		  current_direction = yyvsp[-2].pstate->dir;
		  yyval.spec = new object_spec(BLOCK_OBJECT);
		  olist.wrap_up_block(& yyval.spec->oblist);
		  yyval.spec->tbl = current_table;
		  current_table = yyvsp[-2].pstate->tbl;
		  current_saved_state = yyvsp[-2].pstate->prev;
		  delete yyvsp[-2].pstate;
		;
    break;}
case 84:
#line 679 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->height = yyvsp[0].x;
		  yyval.spec->flags |= HAS_HEIGHT;
		;
    break;}
case 85:
#line 685 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->radius = yyvsp[0].x;
		  yyval.spec->flags |= HAS_RADIUS;
		;
    break;}
case 86:
#line 691 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->width = yyvsp[0].x;
		  yyval.spec->flags |= HAS_WIDTH;
		;
    break;}
case 87:
#line 697 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->radius = yyvsp[0].x/2.0;
		  yyval.spec->flags |= HAS_RADIUS;
		;
    break;}
case 88:
#line 703 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->flags |= HAS_SEGMENT;
		  switch (yyval.spec->dir) {
		  case UP_DIRECTION:
		    yyval.spec->segment_pos.y += yyvsp[0].x;
		    break;
		  case DOWN_DIRECTION:
		    yyval.spec->segment_pos.y -= yyvsp[0].x;
		    break;
		  case RIGHT_DIRECTION:
		    yyval.spec->segment_pos.x += yyvsp[0].x;
		    break;
		  case LEFT_DIRECTION:
		    yyval.spec->segment_pos.x -= yyvsp[0].x;
		    break;
		  }
		;
    break;}
case 89:
#line 722 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->dir = UP_DIRECTION;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.y += yyval.spec->segment_height;
		;
    break;}
case 90:
#line 729 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->dir = UP_DIRECTION;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.y += yyvsp[0].x;
		;
    break;}
case 91:
#line 736 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->dir = DOWN_DIRECTION;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.y -= yyval.spec->segment_height;
		;
    break;}
case 92:
#line 743 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->dir = DOWN_DIRECTION;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.y -= yyvsp[0].x;
		;
    break;}
case 93:
#line 750 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->dir = RIGHT_DIRECTION;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.x += yyval.spec->segment_width;
		;
    break;}
case 94:
#line 757 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->dir = RIGHT_DIRECTION;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.x += yyvsp[0].x;
		;
    break;}
case 95:
#line 764 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->dir = LEFT_DIRECTION;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.x -= yyval.spec->segment_width;
		;
    break;}
case 96:
#line 771 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->dir = LEFT_DIRECTION;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.x -= yyvsp[0].x;
		;
    break;}
case 97:
#line 778 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->flags |= HAS_FROM;
		  yyval.spec->from.x = yyvsp[0].pair.x;
		  yyval.spec->from.y = yyvsp[0].pair.y;
		;
    break;}
case 98:
#line 785 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  if (yyval.spec->flags & HAS_SEGMENT)
		    yyval.spec->segment_list = new segment(yyval.spec->segment_pos,
						   yyval.spec->segment_is_absolute,
						   yyval.spec->segment_list);
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.x = yyvsp[0].pair.x;
		  yyval.spec->segment_pos.y = yyvsp[0].pair.y;
		  yyval.spec->segment_is_absolute = 1;
		  yyval.spec->flags |= HAS_TO;
		  yyval.spec->to.x = yyvsp[0].pair.x;
		  yyval.spec->to.y = yyvsp[0].pair.y;
		;
    break;}
case 99:
#line 800 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->flags |= HAS_AT;
		  yyval.spec->at.x = yyvsp[0].pair.x;
		  yyval.spec->at.y = yyvsp[0].pair.y;
		  if (yyval.spec->type != ARC_OBJECT) {
		    yyval.spec->flags |= HAS_FROM;
		    yyval.spec->from.x = yyvsp[0].pair.x;
		    yyval.spec->from.y = yyvsp[0].pair.y;
		  }
		;
    break;}
case 100:
#line 812 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->flags |= HAS_WITH;
		  yyval.spec->with = yyvsp[0].pth;
		;
    break;}
case 101:
#line 818 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.x += yyvsp[0].pair.x;
		  yyval.spec->segment_pos.y += yyvsp[0].pair.y;
		;
    break;}
case 102:
#line 825 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  if (yyval.spec->flags & HAS_SEGMENT) {
		    yyval.spec->segment_list = new segment(yyval.spec->segment_pos,
						   yyval.spec->segment_is_absolute,
						   yyval.spec->segment_list);
		    yyval.spec->flags &= ~HAS_SEGMENT;
		    yyval.spec->segment_pos.x = yyval.spec->segment_pos.y = 0.0;
		    yyval.spec->segment_is_absolute = 0;
		  }
		;
    break;}
case 103:
#line 837 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->flags |= IS_DOTTED;
		  lookup_variable("dashwid", & yyval.spec->dash_width);
		;
    break;}
case 104:
#line 843 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->flags |= IS_DOTTED;
		  yyval.spec->dash_width = yyvsp[0].x;
		;
    break;}
case 105:
#line 849 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->flags |= IS_DASHED;
		  lookup_variable("dashwid", & yyval.spec->dash_width);
		;
    break;}
case 106:
#line 855 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->flags |= IS_DASHED;
		  yyval.spec->dash_width = yyvsp[0].x;
		;
    break;}
case 107:
#line 861 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->flags |= IS_DEFAULT_FILLED;
		;
    break;}
case 108:
#line 866 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->flags |= IS_FILLED;
		  yyval.spec->fill = yyvsp[0].x;
		;
    break;}
case 109:
#line 872 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  // line chop chop means line chop 0 chop 0
		  if (yyval.spec->flags & IS_DEFAULT_CHOPPED) {
		    yyval.spec->flags |= IS_CHOPPED;
		    yyval.spec->flags &= ~IS_DEFAULT_CHOPPED;
		    yyval.spec->start_chop = yyval.spec->end_chop = 0.0;
		  }
		  else if (yyval.spec->flags & IS_CHOPPED) {
		    yyval.spec->end_chop = 0.0;
		  }
		  else {
		    yyval.spec->flags |= IS_DEFAULT_CHOPPED;
		  }
		;
    break;}
case 110:
#line 888 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  if (yyval.spec->flags & IS_DEFAULT_CHOPPED) {
		    yyval.spec->flags |= IS_CHOPPED;
		    yyval.spec->flags &= ~IS_DEFAULT_CHOPPED;
		    yyval.spec->start_chop = 0.0;
		    yyval.spec->end_chop = yyvsp[0].x;
		  }
		  else if (yyval.spec->flags & IS_CHOPPED) {
		    yyval.spec->end_chop = yyvsp[0].x;
		  }
		  else {
		    yyval.spec->start_chop = yyval.spec->end_chop = yyvsp[0].x;
		    yyval.spec->flags |= IS_CHOPPED;
		  }
		;
    break;}
case 111:
#line 905 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->flags |= IS_SAME;
		;
    break;}
case 112:
#line 910 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->flags |= IS_INVISIBLE;
		;
    break;}
case 113:
#line 915 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->flags |= HAS_LEFT_ARROW_HEAD;
		;
    break;}
case 114:
#line 920 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->flags |= HAS_RIGHT_ARROW_HEAD;
		;
    break;}
case 115:
#line 925 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->flags |= (HAS_LEFT_ARROW_HEAD|HAS_RIGHT_ARROW_HEAD);
		;
    break;}
case 116:
#line 930 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->flags |= IS_CLOCKWISE;
		;
    break;}
case 117:
#line 935 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->flags &= ~IS_CLOCKWISE;
		;
    break;}
case 118:
#line 940 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  for (text_item **p = & yyval.spec->text; *p; p = &(*p)->next)
		    ;
		  *p = new text_item(yyvsp[0].lstr.str, yyvsp[0].lstr.filename, yyvsp[0].lstr.lineno);
		;
    break;}
case 119:
#line 947 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  if (yyval.spec->text) {
		    for (text_item *p = yyval.spec->text; p->next; p = p->next)
		      ;
		    p->adj.h = LEFT_ADJUST;
		  }
		;
    break;}
case 120:
#line 956 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  if (yyval.spec->text) {
		    for (text_item *p = yyval.spec->text; p->next; p = p->next)
		      ;
		    p->adj.h = RIGHT_ADJUST;
		  }
		;
    break;}
case 121:
#line 965 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  if (yyval.spec->text) {
		    for (text_item *p = yyval.spec->text; p->next; p = p->next)
		      ;
		    p->adj.v = ABOVE_ADJUST;
		  }
		;
    break;}
case 122:
#line 974 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  if (yyval.spec->text) {
		    for (text_item *p = yyval.spec->text; p->next; p = p->next)
		      ;
		    p->adj.v = BELOW_ADJUST;
		  }
		;
    break;}
case 123:
#line 983 "pic.y"
{
		  yyval.spec = yyvsp[-2].spec;
		  yyval.spec->flags |= HAS_THICKNESS;
		  yyval.spec->thickness = yyvsp[0].x;
		;
    break;}
case 124:
#line 989 "pic.y"
{
		  yyval.spec = yyvsp[-1].spec;
		  yyval.spec->flags |= IS_ALIGNED;
		;
    break;}
case 125:
#line 997 "pic.y"
{
		  yyval.lstr = yyvsp[0].lstr;
		;
    break;}
case 126:
#line 1001 "pic.y"
{
		  yyval.lstr.filename = yyvsp[-2].lstr.filename;
		  yyval.lstr.lineno = yyvsp[-2].lstr.lineno;
		  yyval.lstr.str = do_sprintf(yyvsp[-2].lstr.str, yyvsp[-1].dv.v, yyvsp[-1].dv.nv);
		  a_delete yyvsp[-1].dv.v;
		  a_delete yyvsp[-2].lstr.str;
		;
    break;}
case 127:
#line 1012 "pic.y"
{
		  yyval.dv.v = 0;
		  yyval.dv.nv = 0;
		  yyval.dv.maxv = 0;
		;
    break;}
case 128:
#line 1018 "pic.y"
{
		  yyval.dv = yyvsp[-2].dv;
		  if (yyval.dv.nv >= yyval.dv.maxv) {
		    if (yyval.dv.nv == 0) {
		      yyval.dv.v = new double[4];
		      yyval.dv.maxv = 4;
		    }
		    else {
		      double *oldv = yyval.dv.v;
		      yyval.dv.maxv *= 2;
		      yyval.dv.v = new double[yyval.dv.maxv];
		      memcpy(yyval.dv.v, oldv, yyval.dv.nv*sizeof(double));
		      a_delete oldv;
		    }
		  }
		  yyval.dv.v[yyval.dv.nv] = yyvsp[0].x;
		  yyval.dv.nv += 1;
		;
    break;}
case 129:
#line 1040 "pic.y"
{ yyval.pair = yyvsp[0].pair; ;
    break;}
case 130:
#line 1042 "pic.y"
{
		  position pos = yyvsp[0].pl;
		  yyval.pair.x = pos.x;
		  yyval.pair.y = pos.y;
		;
    break;}
case 131:
#line 1051 "pic.y"
{ yyval.pair = yyvsp[0].pair; ;
    break;}
case 132:
#line 1053 "pic.y"
{
		  yyval.pair.x = yyvsp[-2].pair.x + yyvsp[0].pair.x;
		  yyval.pair.y = yyvsp[-2].pair.y + yyvsp[0].pair.y;
		;
    break;}
case 133:
#line 1058 "pic.y"
{
		  yyval.pair.x = yyvsp[-2].pair.x - yyvsp[0].pair.x;
		  yyval.pair.y = yyvsp[-2].pair.y - yyvsp[0].pair.y;
		;
    break;}
case 134:
#line 1063 "pic.y"
{
		  yyval.pair.x = yyvsp[-3].pair.x;
		  yyval.pair.y = yyvsp[-1].pair.y;
		;
    break;}
case 135:
#line 1068 "pic.y"
{
		  yyval.pair.x = (1.0 - yyvsp[-4].x)*yyvsp[-2].pair.x + yyvsp[-4].x*yyvsp[0].pair.x;
		  yyval.pair.y = (1.0 - yyvsp[-4].x)*yyvsp[-2].pair.y + yyvsp[-4].x*yyvsp[0].pair.y;
		;
    break;}
case 136:
#line 1073 "pic.y"
{
		  yyval.pair.x = (1.0 - yyvsp[-5].x)*yyvsp[-3].pair.x + yyvsp[-5].x*yyvsp[-1].pair.x;
		  yyval.pair.y = (1.0 - yyvsp[-5].x)*yyvsp[-3].pair.y + yyvsp[-5].x*yyvsp[-1].pair.y;
		;
    break;}
case 139:
#line 1086 "pic.y"
{ yyval.pair.x = yyvsp[-2].x; yyval.pair.y = yyvsp[0].x; ;
    break;}
case 140:
#line 1088 "pic.y"
{ yyval.pair = yyvsp[-1].pair; ;
    break;}
case 141:
#line 1093 "pic.y"
{ yyval.pl = yyvsp[0].pl; ;
    break;}
case 142:
#line 1095 "pic.y"
{
		  path pth(yyvsp[0].crn);
		  if (!pth.follow(yyvsp[-1].pl, & yyval.pl))
		    YYABORT;
		;
    break;}
case 143:
#line 1101 "pic.y"
{
		  path pth(yyvsp[-1].crn);
		  if (!pth.follow(yyvsp[0].pl, & yyval.pl))
		    YYABORT;
		;
    break;}
case 144:
#line 1107 "pic.y"
{
		  path pth(yyvsp[-2].crn);
		  if (!pth.follow(yyvsp[0].pl, & yyval.pl))
		    YYABORT;
		;
    break;}
case 145:
#line 1113 "pic.y"
{
		  yyval.pl.x = current_position.x;
		  yyval.pl.y = current_position.y;
		  yyval.pl.obj = 0;
		;
    break;}
case 146:
#line 1122 "pic.y"
{
		  place *p = lookup_label(yyvsp[0].str);
		  if (!p) {
		    lex_error("there is no place `%1'", yyvsp[0].str);
		    YYABORT;
		  }
		  yyval.pl = *p;
		  a_delete yyvsp[0].str;
		;
    break;}
case 147:
#line 1132 "pic.y"
{
		  yyval.pl.obj = yyvsp[0].obj;
		;
    break;}
case 148:
#line 1136 "pic.y"
{
		  path pth(yyvsp[0].str);
		  if (!pth.follow(yyvsp[-2].pl, & yyval.pl))
		    YYABORT;
		;
    break;}
case 149:
#line 1145 "pic.y"
{ yyval.n = 1; ;
    break;}
case 150:
#line 1147 "pic.y"
{ yyval.n = yyvsp[-1].n; ;
    break;}
case 151:
#line 1152 "pic.y"
{
		  int count = 0;
		  for (object *p = olist.head; p != 0; p = p->next)
		    if (p->type() == yyvsp[0].obtype && ++count == yyvsp[-1].n) {
		      yyval.obj = p;
		      break;
		    }
		  if (p == 0) {
		    lex_error("there is no %1%2 %3", yyvsp[-1].n, ordinal_postfix(yyvsp[-1].n),
			      object_type_name(yyvsp[0].obtype));
		    YYABORT;
		  }
		;
    break;}
case 152:
#line 1166 "pic.y"
{
		  int count = 0;
		  for (object *p = olist.tail; p != 0; p = p->prev)
		    if (p->type() == yyvsp[0].obtype && ++count == yyvsp[-1].n) {
		      yyval.obj = p;
		      break;
		    }
		  if (p == 0) {
		    lex_error("there is no %1%2 last %3", yyvsp[-1].n,
			      ordinal_postfix(yyvsp[-1].n), object_type_name(yyvsp[0].obtype));
		    YYABORT;
		  }
		;
    break;}
case 153:
#line 1183 "pic.y"
{ yyval.obtype = BOX_OBJECT; ;
    break;}
case 154:
#line 1185 "pic.y"
{ yyval.obtype = CIRCLE_OBJECT; ;
    break;}
case 155:
#line 1187 "pic.y"
{ yyval.obtype = ELLIPSE_OBJECT; ;
    break;}
case 156:
#line 1189 "pic.y"
{ yyval.obtype = ARC_OBJECT; ;
    break;}
case 157:
#line 1191 "pic.y"
{ yyval.obtype = LINE_OBJECT; ;
    break;}
case 158:
#line 1193 "pic.y"
{ yyval.obtype = ARROW_OBJECT; ;
    break;}
case 159:
#line 1195 "pic.y"
{ yyval.obtype = SPLINE_OBJECT; ;
    break;}
case 160:
#line 1197 "pic.y"
{ yyval.obtype = BLOCK_OBJECT; ;
    break;}
case 161:
#line 1199 "pic.y"
{ yyval.obtype = TEXT_OBJECT; ;
    break;}
case 162:
#line 1204 "pic.y"
{
		  yyval.pth = new path(yyvsp[0].str);
		;
    break;}
case 163:
#line 1208 "pic.y"
{
		  yyval.pth = yyvsp[-2].pth;
		  yyval.pth->append(yyvsp[0].str);
		;
    break;}
case 164:
#line 1216 "pic.y"
{
		  yyval.pth = new path(yyvsp[0].crn);
		;
    break;}
case 165:
#line 1223 "pic.y"
{
		  yyval.pth = yyvsp[0].pth;
		;
    break;}
case 166:
#line 1227 "pic.y"
{
		  yyval.pth = yyvsp[-1].pth;
		  yyval.pth->append(yyvsp[0].crn);
		;
    break;}
case 167:
#line 1235 "pic.y"
{
		  yyval.pth = yyvsp[0].pth;
		;
    break;}
case 168:
#line 1240 "pic.y"
{
		  lex_warning("`%1%2 last %3' in `with' argument ignored",
			      yyvsp[-3].n, ordinal_postfix(yyvsp[-3].n), object_type_name(yyvsp[-1].obtype));
		  yyval.pth = yyvsp[0].pth;
		;
    break;}
case 169:
#line 1246 "pic.y"
{
		  lex_warning("`last %1' in `with' argument ignored",
			      object_type_name(yyvsp[-1].obtype));
		  yyval.pth = yyvsp[0].pth;
		;
    break;}
case 170:
#line 1252 "pic.y"
{
		  lex_warning("`%1%2 %3' in `with' argument ignored",
			      yyvsp[-2].n, ordinal_postfix(yyvsp[-2].n), object_type_name(yyvsp[-1].obtype));
		  yyval.pth = yyvsp[0].pth;
		;
    break;}
case 171:
#line 1258 "pic.y"
{
		  lex_warning("initial `%1' in `with' argument ignored", yyvsp[-1].str);
		  a_delete yyvsp[-1].str;
		  yyval.pth = yyvsp[0].pth;
		;
    break;}
case 172:
#line 1267 "pic.y"
{ yyval.crn = &object::north; ;
    break;}
case 173:
#line 1269 "pic.y"
{ yyval.crn = &object::east; ;
    break;}
case 174:
#line 1271 "pic.y"
{ yyval.crn = &object::west; ;
    break;}
case 175:
#line 1273 "pic.y"
{ yyval.crn = &object::south; ;
    break;}
case 176:
#line 1275 "pic.y"
{ yyval.crn = &object::north_east; ;
    break;}
case 177:
#line 1277 "pic.y"
{ yyval.crn = &object:: south_east; ;
    break;}
case 178:
#line 1279 "pic.y"
{ yyval.crn = &object::north_west; ;
    break;}
case 179:
#line 1281 "pic.y"
{ yyval.crn = &object::south_west; ;
    break;}
case 180:
#line 1283 "pic.y"
{ yyval.crn = &object::center; ;
    break;}
case 181:
#line 1285 "pic.y"
{ yyval.crn = &object::start; ;
    break;}
case 182:
#line 1287 "pic.y"
{ yyval.crn = &object::end; ;
    break;}
case 183:
#line 1289 "pic.y"
{ yyval.crn = &object::north; ;
    break;}
case 184:
#line 1291 "pic.y"
{ yyval.crn = &object::south; ;
    break;}
case 185:
#line 1293 "pic.y"
{ yyval.crn = &object::west; ;
    break;}
case 186:
#line 1295 "pic.y"
{ yyval.crn = &object::east; ;
    break;}
case 187:
#line 1297 "pic.y"
{ yyval.crn = &object::north_west; ;
    break;}
case 188:
#line 1299 "pic.y"
{ yyval.crn = &object::south_west; ;
    break;}
case 189:
#line 1301 "pic.y"
{ yyval.crn = &object::north_east; ;
    break;}
case 190:
#line 1303 "pic.y"
{ yyval.crn = &object::south_east; ;
    break;}
case 191:
#line 1305 "pic.y"
{ yyval.crn = &object::west; ;
    break;}
case 192:
#line 1307 "pic.y"
{ yyval.crn = &object::east; ;
    break;}
case 193:
#line 1309 "pic.y"
{ yyval.crn = &object::north_west; ;
    break;}
case 194:
#line 1311 "pic.y"
{ yyval.crn = &object::south_west; ;
    break;}
case 195:
#line 1313 "pic.y"
{ yyval.crn = &object::north_east; ;
    break;}
case 196:
#line 1315 "pic.y"
{ yyval.crn = &object::south_east; ;
    break;}
case 197:
#line 1317 "pic.y"
{ yyval.crn = &object::center; ;
    break;}
case 198:
#line 1319 "pic.y"
{ yyval.crn = &object::start; ;
    break;}
case 199:
#line 1321 "pic.y"
{ yyval.crn = &object::end; ;
    break;}
case 200:
#line 1326 "pic.y"
{
		  if (!lookup_variable(yyvsp[0].str, & yyval.x)) {
		    lex_error("there is no variable `%1'", yyvsp[0].str);
		    YYABORT;
		  }
		  a_delete yyvsp[0].str;
		;
    break;}
case 201:
#line 1334 "pic.y"
{ yyval.x = yyvsp[0].x; ;
    break;}
case 202:
#line 1336 "pic.y"
{
		  if (yyvsp[-1].pl.obj != 0)
		    yyval.x = yyvsp[-1].pl.obj->origin().x;
		  else
		    yyval.x = yyvsp[-1].pl.x;
		;
    break;}
case 203:
#line 1343 "pic.y"
{
		  if (yyvsp[-1].pl.obj != 0)
		    yyval.x = yyvsp[-1].pl.obj->origin().y;
		  else
		    yyval.x = yyvsp[-1].pl.y;
		;
    break;}
case 204:
#line 1350 "pic.y"
{
		  if (yyvsp[-1].pl.obj != 0)
		    yyval.x = yyvsp[-1].pl.obj->height();
		  else
		    yyval.x = 0.0;
		;
    break;}
case 205:
#line 1357 "pic.y"
{
		  if (yyvsp[-1].pl.obj != 0)
		    yyval.x = yyvsp[-1].pl.obj->width();
		  else
		    yyval.x = 0.0;
		;
    break;}
case 206:
#line 1364 "pic.y"
{
		  if (yyvsp[-1].pl.obj != 0)
		    yyval.x = yyvsp[-1].pl.obj->radius();
		  else
		    yyval.x = 0.0;
		;
    break;}
case 207:
#line 1371 "pic.y"
{ yyval.x = yyvsp[-2].x + yyvsp[0].x; ;
    break;}
case 208:
#line 1373 "pic.y"
{ yyval.x = yyvsp[-2].x - yyvsp[0].x; ;
    break;}
case 209:
#line 1375 "pic.y"
{ yyval.x = yyvsp[-2].x * yyvsp[0].x; ;
    break;}
case 210:
#line 1377 "pic.y"
{
		  if (yyvsp[0].x == 0.0) {
		    lex_error("division by zero");
		    YYABORT;
		  }
		  yyval.x = yyvsp[-2].x/yyvsp[0].x;
		;
    break;}
case 211:
#line 1385 "pic.y"
{
		  if (yyvsp[0].x == 0.0) {
		    lex_error("modulus by zero");
		    YYABORT;
		  }
		  yyval.x = fmod(yyvsp[-2].x, yyvsp[0].x);
		;
    break;}
case 212:
#line 1393 "pic.y"
{
		  errno = 0;
		  yyval.x = pow(yyvsp[-2].x, yyvsp[0].x);
		  if (errno == EDOM) {
		    lex_error("arguments to `^' operator out of domain");
		    YYABORT;
		  }
		  if (errno == ERANGE) {
		    lex_error("result of `^' operator out of range");
		    YYABORT;
		  }
		;
    break;}
case 213:
#line 1406 "pic.y"
{ yyval.x = -yyvsp[0].x; ;
    break;}
case 214:
#line 1408 "pic.y"
{ yyval.x = yyvsp[-1].x; ;
    break;}
case 215:
#line 1410 "pic.y"
{
		  errno = 0;
		  yyval.x = sin(yyvsp[-1].x);
		  if (errno == ERANGE) {
		    lex_error("sin result out of range");
		    YYABORT;
		  }
		;
    break;}
case 216:
#line 1419 "pic.y"
{
		  errno = 0;
		  yyval.x = cos(yyvsp[-1].x);
		  if (errno == ERANGE) {
		    lex_error("cos result out of range");
		    YYABORT;
		  }
		;
    break;}
case 217:
#line 1428 "pic.y"
{
		  errno = 0;
		  yyval.x = atan2(yyvsp[-3].x, yyvsp[-1].x);
		  if (errno == EDOM) {
		    lex_error("atan2 argument out of domain");
		    YYABORT;
		  }
		  if (errno == ERANGE) {
		    lex_error("atan2 result out of range");
		    YYABORT;
		  }
		;
    break;}
case 218:
#line 1441 "pic.y"
{
		  errno = 0;
		  yyval.x = log10(yyvsp[-1].x);
		  if (errno == ERANGE) {
		    lex_error("log result out of range");
		    YYABORT;
		  }
		;
    break;}
case 219:
#line 1450 "pic.y"
{
		  errno = 0;
		  yyval.x = pow(10.0, yyvsp[-1].x);
		  if (errno == ERANGE) {
		    lex_error("exp result out of range");
		    YYABORT;
		  }
		;
    break;}
case 220:
#line 1459 "pic.y"
{
		  errno = 0;
		  yyval.x = sqrt(yyvsp[-1].x);
		  if (errno == EDOM) {
		    lex_error("sqrt argument out of domain");
		    YYABORT;
		  }
		;
    break;}
case 221:
#line 1468 "pic.y"
{ yyval.x = yyvsp[-3].x > yyvsp[-1].x ? yyvsp[-3].x : yyvsp[-1].x; ;
    break;}
case 222:
#line 1470 "pic.y"
{ yyval.x = yyvsp[-3].x < yyvsp[-1].x ? yyvsp[-3].x : yyvsp[-1].x; ;
    break;}
case 223:
#line 1472 "pic.y"
{ yyval.x = floor(yyvsp[-1].x); ;
    break;}
case 224:
#line 1474 "pic.y"
{ yyval.x = 1.0 + floor(((rand()&0x7fff)/double(0x7fff))*yyvsp[-1].x); ;
    break;}
case 225:
#line 1476 "pic.y"
{
		  /* return a random number in the range [0,1) */
		  /* portable, but not very random */
		  yyval.x = (rand() & 0x7fff) / double(0x8000);
		;
    break;}
case 226:
#line 1482 "pic.y"
{ yyval.x = (yyvsp[-2].x < yyvsp[0].x); ;
    break;}
case 227:
#line 1484 "pic.y"
{ yyval.x = (yyvsp[-2].x <= yyvsp[0].x); ;
    break;}
case 228:
#line 1486 "pic.y"
{ yyval.x = (yyvsp[-2].x > yyvsp[0].x); ;
    break;}
case 229:
#line 1488 "pic.y"
{ yyval.x = (yyvsp[-2].x >= yyvsp[0].x); ;
    break;}
case 230:
#line 1490 "pic.y"
{ yyval.x = (yyvsp[-2].x == yyvsp[0].x); ;
    break;}
case 231:
#line 1492 "pic.y"
{ yyval.x = (yyvsp[-2].x != yyvsp[0].x); ;
    break;}
case 232:
#line 1494 "pic.y"
{ yyval.x = (yyvsp[-2].x != 0.0 && yyvsp[0].x != 0.0); ;
    break;}
case 233:
#line 1496 "pic.y"
{ yyval.x = (yyvsp[-2].x != 0.0 || yyvsp[0].x != 0.0); ;
    break;}
case 234:
#line 1498 "pic.y"
{ yyval.x = (yyvsp[0].x == 0.0); ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 423 "/usr/local/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  for (x = 0; x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) xmalloc(size + 15);
	  strcpy(msg, "parse error");

	  if (count < 5)
	    {
	      count = 0;
	      for (x = 0; x < (sizeof(yytname) / sizeof(char *)); x++)
		if (yycheck[x + yyn] == x)
		  {
		    strcat(msg, count == 0 ? ", expecting `" : " or `");
		    strcat(msg, yytname[x]);
		    strcat(msg, "'");
		    count++;
		  }
	    }
	  yyerror(msg);
	  free(msg);
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 1502 "pic.y"


/* bison defines const to be empty unless __STDC__ is defined, which it
isn't under cfront */

#ifdef const
#undef const
#endif

static struct {
  const char *name;
  double val;
  int scaled;		     // non-zero if val should be multiplied by scale
} defaults_table[] = {
  "arcrad", .25, 1,
  "arrowht", .1, 1,
  "arrowwid", .05, 1,
  "circlerad", .25, 1,
  "boxht", .5, 1,
  "boxwid", .75, 1,
  "boxrad", 0.0, 1,
  "dashwid", .05, 1,
  "ellipseht", .5, 1,
  "ellipsewid", .75, 1,
  "moveht", .5, 1,
  "movewid", .5, 1,
  "lineht", .5, 1,
  "linewid", .5, 1,
  "textht", 0.0, 1,
  "textwid", 0.0, 1,
  "scale", 1.0, 0,
  "linethick", -1.0, 0,		// in points
  "fillval", .5, 0,
  "arrowhead", 1.0, 0,
  "maxpswid", 8.5, 0,
  "maxpsht", 11.0, 0,
};

place *lookup_label(const char *label)
{
  saved_state *state = current_saved_state;
  PTABLE(place) *tbl = current_table;
  for (;;) {
    place *pl = tbl->lookup(label);
    if (pl)
      return pl;
    if (!state)
      return 0;
    tbl = state->tbl;
    state = state->prev;
  }
}

void define_label(const char *label, const place *pl)
{
  place *p = new place;
  *p = *pl;
  current_table->define(label, p);
}

int lookup_variable(const char *name, double *val)
{
  place *pl = lookup_label(name);
  if (pl) {
    *val = pl->x;
    return 1;
  }
  return 0;
}

void define_variable(const char *name, double val)
{
  place *p = new place;
  p->obj = 0;
  p->x = val;
  p->y = 0.0;
  current_table->define(name, p);
  if (strcmp(name, "scale") == 0) {
    // When the scale changes, reset all scaled pre-defined variables to
    // their default values.
    for (int i = 0; i < sizeof(defaults_table)/sizeof(defaults_table[0]); i++)
      if (defaults_table[i].scaled)
	define_variable(defaults_table[i].name, val*defaults_table[i].val);
  }
}

// called once only (not once per parse)

void parse_init()
{
  current_direction = RIGHT_DIRECTION;
  current_position.x = 0.0;
  current_position.y = 0.0;
  // This resets everything to its default value.
  reset_all();
}

void reset(const char *nm)
{
  for (int i = 0; i < sizeof(defaults_table)/sizeof(defaults_table[0]); i++)
    if (strcmp(nm, defaults_table[i].name) == 0) {
      double val = defaults_table[i].val;
      if (defaults_table[i].scaled) {
	double scale;
	lookup_variable("scale", &scale);
	val *= scale;
      }
      define_variable(defaults_table[i].name, val);
      return;
    }
  lex_error("`%1' is not a predefined variable", nm);
}

void reset_all()
{
  // We only have to explicitly reset the pre-defined variables that
  // aren't scaled because `scale' is not scaled, and changing the
  // value of `scale' will reset all the pre-defined variables that
  // are scaled.
  for (int i = 0; i < sizeof(defaults_table)/sizeof(defaults_table[0]); i++)
    if (!defaults_table[i].scaled)
      define_variable(defaults_table[i].name, defaults_table[i].val);
}

// called after each parse

void parse_cleanup()
{
  while (current_saved_state != 0) {
    delete current_table;
    current_table = current_saved_state->tbl;
    saved_state *tem = current_saved_state;
    current_saved_state = current_saved_state->prev;
    delete tem;
  }
  assert(current_table == &top_table);
  PTABLE_ITERATOR(place) iter(current_table);
  const char *key;
  place *pl;
  while (iter.next(&key, &pl))
    if (pl->obj != 0) {
      position pos = pl->obj->origin();
      pl->obj = 0;
      pl->x = pos.x;
      pl->y = pos.y;
    }
  while (olist.head != 0) {
    object *tem = olist.head;
    olist.head = olist.head->next;
    delete tem;
  }
  olist.tail = 0;
  current_direction = RIGHT_DIRECTION;
  current_position.x = 0.0;
  current_position.y = 0.0;
}

const char *ordinal_postfix(int n)
{
  if (n < 10 || n > 20)
    switch (n % 10) {
    case 1:
      return "st";
    case 2:
      return "nd";
    case 3:
      return "rd";
    }
  return "th";
}

const char *object_type_name(object_type type)
{
  switch (type) {
  case BOX_OBJECT:
    return "box";
  case CIRCLE_OBJECT:
    return "circle";
  case ELLIPSE_OBJECT:
    return "ellipse";
  case ARC_OBJECT:
    return "arc";
  case SPLINE_OBJECT:
    return "spline";
  case LINE_OBJECT:
    return "line";
  case ARROW_OBJECT:
    return "arrow";
  case MOVE_OBJECT:
    return "move";
  case TEXT_OBJECT:
    return "\"\"";
  case BLOCK_OBJECT:
    return "[]";
  case OTHER_OBJECT:
  case MARK_OBJECT:
  default:
    break;
  }
  return "object";
}

static char sprintf_buf[1024];

char *format_number(const char *form, double n)
{
  if (form == 0)
    form = "%g";
  else {
    // this is a fairly feeble attempt at validation of the format
    int nspecs = 0;
    for (const char *p = form; *p != '\0'; p++)
      if (*p == '%') {
	if (p[1] == '%')
	  p++;
	else
	  nspecs++;
      }
    if (nspecs > 1) {
      lex_error("bad format `%1'", form);
      return strsave(form);
    }
  }
  sprintf(sprintf_buf, form, n);
  return strsave(sprintf_buf);
}

char *do_sprintf(const char *form, const double *v, int nv)
{
  string result;
  int i = 0;
  string one_format;
  while (*form) {
    if (*form == '%') {
      one_format += *form++;
      for (; *form != '\0' && strchr("#-+ 0123456789.", *form) != 0; form++)
	one_format += *form;
      if (*form == '\0' || strchr("eEfgG%", *form) == 0) {
	lex_error("bad sprintf format");
	result += one_format;
	result += form;
	break;
      }
      if (*form == '%') {
	one_format += *form++;
	one_format += '\0';
	sprintf(sprintf_buf, one_format.contents());
      }
      else {
	if (i >= nv) {
	  lex_error("too few arguments to sprintf");
	  result += one_format;
	  result += form;
	  break;
	}
	one_format += *form++;
	one_format += '\0';
	sprintf(sprintf_buf, one_format.contents(), v[i++]);
      }
      one_format.clear();
      result += sprintf_buf;
    }
    else
      result += *form++;
  }
  result += '\0';
  return strsave(result.contents());
}
