NAME
     chmod - change the access permissions of files

SYNOPSIS
     chmod [-LRcfv] mode file...

DESCRIPTION
     This manual page documents the GNU version of chmod.  chmod
     changes the permissions of each given file according to
     mode, which can be either a symbolic representation of
     changes to make, or an octal number representing the bit
     pattern for the new permissions.

     The format of a symbolic mode is `[ugoa...][[+-
     =][rwxXstugo...]...][,...]'.  Multiple symbolic operations
     can be given, separated by commas.

     A combination of the letters `ugoa' controls which users'
     access to the file will be changed: the user who owns it
     (u), other users in the file's group (g), other users not in
     the file's group (o), or all users (a).  If none of these
     are given, the effect is as if `a' were given, but bits that
     are set in the umask are not affected.

     The operator `+' causes the permissions selected to be added
     to the existing permissions of each file; `-' causes them to
     be removed; and `=' causes them to be the only permissions
     that the file has.

     The letters `rwxXstugo' select the new permissions for the
     affected users: read (r), write (w), execute (or access for
     directories) (x), execute only if the file is a directory or
     already has execute permission for some user (X), set user
     or group ID on execution (s), save program text on swap dev-
     ice (t), the permissions that the user who owns the file
     currently has for it (u), the permissions that other users
     in the file's group have for it (g), and the permissions
     that other users not in the file's group have for it (o).

     A numeric mode is from one to four octal digits (0-7),
     derived by adding up the bits with values 4, 2, and 1.  Any
     omitted digits are assumed to be leading zeros.  The first
     digit selects the set user ID (4) and set group ID (2) and
     save text image (1) attributes.  The second digit selects
     permissions for the user who owns the file: read (4), write
     (2), and execute (1); the third selects permissions for
     other users in the file's group, with the same values; and
     the fourth for other users not in the file's group, with the
     same values.

     OPTIONS

     -c   Verbosely describe only files whose permissions actu-
          ally change.

     -f   Do not print error messages about files whose permis-
          sions cannot be changed.

     -v   Verbosely describe changed permissions.

     -L   Dereference symbolic links (recursively change the per-
          missions of directories pointed to by symbolic links).

     -R   Recursively change permissions of directories.
