NAME
     split - split a file into pieces

SYNOPSIS
     split [-lines] [-l lines] [-c bytes] [-C bytes]
     [+lines=lines] [+bytes=bytes] [+line-bytes=bytes] [infile
     [outfile-prefix]]

DESCRIPTION
     This manual page documents the GNU version of split.  split
     reads the given infile, or the standard input if none is
     given or the name `-' is given.  It creates one or more out-
     put files (as many as necessary) containing consecutive sec-
     tions of the input file.  By default, split puts 1000 lines
     of the input file, or whatever is left if it is less than
     that, into each output file.

     The output file names consist of a prefix followed by a
     group of letters, chosen so that concatenating the output
     files in sorted order by file name produces the original
     input file, in order.  The default output file name prefix
     is `x'.  If the outfile-prefix argument is given, it is used
     as the output file name prefix instead.

     OPTIONS

     -lines, -l lines, +lines=lines
          Put lines lines of the input file into each output
          file.

     -c bytes, +bytes=bytes
          Put bytes bytes of the input file into each output
          file.

     -C bytes, +line-bytes=bytes
          Put into each output file as many complete lines of the
          input file as is possible without exceeding bytes
          bytes.  If a line that is longer than bytes bytes
          occurs, put bytes bytes of it into each output file
          until less than bytes bytes of the line are left, then
          continue normally.
