NAME
     touch - change file timestamps

SYNOPSIS
     touch [-acm] [-r reference-file] [-t MMDDhhmm[[CC]YY][.ss]]
     [-d time] [+time={atime,access,use,mtime,modify}]
     [+date=time] [+file=reference-file] [+no-create] file...

DESCRIPTION
     This manual page documents the GNU version of touch.  touch
     changes the access and modification times of each given file
     to the current time.  Files that do not exist are created
     empty.  If the first file name given would be a valid argu-
     ment to the -t option and no timestamp is given with any of
     the -d, -r, or -t options and the -- argument is not given,
     that argument is interpreted as the time for the other files
     instead of as a filename.

     OPTIONS

     -a, +time=atime, +time=access, +time=use
          Change the access time only.

     -c, +no-create
          Do not create files that do not exist.

     -d, +date time
          Use time (which can be in various common formats)
          instead of the current time.  Month names, timezones,
          `am' and `pm', etc. are recognized.

     -m, +time=mtime, +time=modify
          Change the modification time only.

     -r, +file reference-file
          Use the times of reference-file instead of the current
          time.

     -t MMDDhhmm[[CC]YY][.ss]
          Use the argument (months, days, hours, minutes,
          optional century and years, optional seconds) instead
          of the current time.
